// cordova-plugin-admob-free
class AdComponent {
	constructor(admob_ids, admob_obj) {
		this.admob_ids = admob_ids;
		this.admob = undefined;
		this.is_ready = false;
		this.closed_callback_caller = undefined;
		this.closed_callback_func = undefined;
		this.load_success_callback_caller = undefined;
		this.load_success_callback_func = undefined;
		this.load_fail_callback_caller = undefined;
		this.load_fail_callback_func = undefined;
		this.is_available = true;
	}

	initAds() {
        console.log("[ad] calling initAds");
        tgsdk.initialize("g971ht8Kf4G00560m7SK");

        this.is_ready = false;
        var self = this;
        tgsdk.onVideoADLoaded = function(ret) {
            self.onGameAdLoadEvent();
        };
        tgsdk.onADClose = function(ret) {
            self.onGameAdClose();
        };
        tgsdk.onShowFailed = function(ret) {
            // Ads fail to play
            self.onGameShowFail();
        };
        console.log("[ad] calling preload");
        this.prepareAds();
        return true;
    }

	prepareAds() {
		this.is_available = true;
		this.is_ready = true;
		tgsdk.preload();
		return true;
	}

	onGameShowFail() {
        this.is_ready = false;
        if (typeof(this.load_success_callback_func) == "function") {
            this.load_fail_callback_func.call(this.load_fail_callback_caller);
        }
    }
    onGameAdLoadEvent() {
        this.is_ready = true;
        if (typeof(this.load_success_callback_func) == "function") {
            console.log("[ad] calling load events");
            this.load_success_callback_func.call(this.load_success_callback_caller);
            this.load_success_callback_func = undefined;
            this.load_success_callback_caller = undefined;
        } else {
            console.log("[ad] calling load events： fail func is " + typeof(this.load_success_callback_func));
        }
        return true;
    }

    onGameAdClose() {
        // Ads are closed
        tgsdk.preload();
        if (typeof(this.closed_callback_func) == "function") {
            console.log("[ad] calling close events");
            this.closed_callback_func.call(this.closed_callback_caller);
            this.closed_callback_func = undefined;
            this.closed_callback_caller = undefined;
        } else {
            console.log("[ad] calling load events： fail func is " + typeof(this.load_success_callback_func));
        }
        return true;
    }

	setClosedCallback(caller, func) {
		if (!this.is_available) return false;
		this.closed_callback_caller = caller;
		this.closed_callback_func = func;
		return true;
	}

	setLoadSuccessCallback(caller, func) {
		if (!this.is_available) return false;
		this.load_success_callback_caller = caller;
		this.load_success_callback_func = func;
		return true;
	}

	setLoadFailCallback(caller, func) {
		if (!this.is_available) return false;
		this.load_fail_callback_caller = caller;
		this.load_fail_callback_func = func;
		return true;
	}

	show(callback_success, callback_fail) {
        console.log("[ad] show...");
        if (!this.is_ready) {
            console.log("[ad] is not ready");
            if (typeof(callback_fail) === "function") {
                callback_fail();
            }
            return;
        }
        tgsdk.couldShowAd(
                        "xrLBMFLuiHeec9rWZLv",
                        function(){
                            window.tgsdk.showAd("xrLBMFLuiHeec9rWZLv");
                        },
                        function() {
                            console.log("[cordova] not ready");
                        }
                    );
    }
}

class RewardAdComponent {
	constructor(admob_ids, admob_obj) {
		this.admob_ids = admob_ids;
		this.admob = undefined;
		this.is_ready = false;
		this.closed_callback_caller = undefined;
		this.closed_callback_func = undefined;
		this.load_success_callback_caller = undefined;
		this.load_success_callback_func = undefined;
		this.load_fail_callback_caller = undefined;
		this.load_fail_callback_func = undefined;
		this.reward_callback_caller = undefined;
		this.reward_callback_func = undefined;
		this.is_available = false;
	}

	initAds() {
        console.log("[ad] calling initAds");
        tgsdk.initialize("g971ht8Kf4G00560m7SK");

        this.is_ready = false;
        var self = this;
        tgsdk.onVideoADLoaded = function(ret) {
            self.onGameAdLoadEvent();
        };
        tgsdk.onADClose = function(ret) {
            self.onGameAdClose();
        };
        tgsdk.onShowFailed = function(ret) {
            // Ads fail to play
            self.onGameShowFail();
        };
        console.log("[ad] calling preload");
        this.prepareAds();
        return true;
    }

	prepareAds() {
		this.is_available = true;
		this.is_ready = true;
		tgsdk.preload();
		return true;
	}

	onGameShowFail() {
        this.is_ready = false;
        if (typeof(this.load_success_callback_func) == "function") {
            this.load_fail_callback_func.call(this.load_fail_callback_caller);
        }
    }
    onGameAdLoadEvent() {
        this.is_ready = true;
        this.is_available = true;
        if (typeof(this.load_success_callback_func) == "function") {
            console.log("[ad] calling load events");
            this.load_success_callback_func.call(this.load_success_callback_caller);
            this.load_success_callback_func = undefined;
            this.load_success_callback_caller = undefined;
        } else {
            console.log("[ad] calling load events： fail func is " + typeof(this.load_success_callback_func));
        }
        return true;
    }

    onGameAdClose() {
        // Ads are closed
        tgsdk.preload();
        if (typeof(this.closed_callback_func) == "function") {
            console.log("[ad] calling close events");
            this.closed_callback_func.call(this.closed_callback_caller);
            this.closed_callback_func = undefined;
            this.closed_callback_caller = undefined;
        } else {
            console.log("[ad] calling load events： fail func is " + typeof(this.load_success_callback_func));
        }
        return true;
    }

	setClosedCallback(caller, func) {
		if (!this.is_available) return false;
		this.closed_callback_caller = caller;
		this.closed_callback_func = func;
		return true;
	}

	setLoadSuccessCallback(caller, func) {
		if (!this.is_available) return false;
		this.load_success_callback_caller = caller;
		this.load_success_callback_func = func;
		return true;
	}

	setLoadFailCallback(caller, func) {
		if (!this.is_available) return false;
		this.load_fail_callback_caller = caller;
		this.load_fail_callback_func = func;
		return true;
	}

	setRewardCallback(caller, func) {
		if (!this.is_available) return false;
		this.reward_callback_caller = caller;
		this.reward_callback_func = func;
		return true;
	}

	show(callback_success, callback_fail) {
        console.log("[ad] show...");
        if (!this.is_ready) {
            console.log("[ad] is not ready");
            if (typeof(callback_fail) === "function") {
                callback_fail();
            }
            return;
        }
        tgsdk.couldShowAd(
                        "xrLBMFLuiHeec9rWZLv",
                        function(){
                            window.tgsdk.showAd("xrLBMFLuiHeec9rWZLv");
                        },
                        function() {
                            console.log("[cordova] not ready");
                        }
                    );
    }
}

class BannerAdComponent {
	constructor(admob_ids, admob_obj) {
		this.admob_ids = admob_ids;
		this.admob = undefined;
		this.is_ready = false;
		this.load_success_callback_caller = undefined;
		this.load_success_callback_func = undefined;
		this.load_fail_callback_caller = undefined;
		this.load_fail_callback_func = undefined;
		this.is_available = this.initAds(admob_obj);
	}

	initAds(admob_obj) {
		if (typeof(admob_obj) === "undefined") return false;
		this.admob = admob_obj;

		this.admob.banner.config({
			id: this.admob_ids[OS_TYPE].banner_id,
			isTesting: false,
			autoShow: false,
		});

		document.addEventListener("admob.banner.events.LOAD", (e) => {
			this.is_ready = true;
			if (typeof(this.load_success_callback_func) == "function") {
				this.load_success_callback_func.call(this.load_success_callback_caller);
				this.load_success_callback_caller = undefined;
				this.load_success_callback_func = undefined;
			}
		});
		document.addEventListener("admob.banner.events.LOAD_FAIL", (e) => {
			this.is_ready = false;
			if (typeof(this.load_success_callback_func) == "function") {
				this.load_fail_callback_func.call(this.load_fail_callback_caller);
				this.load_fail_callback_caller = undefined;
				this.load_fail_callback_func = undefined;
			}
		});

		this.is_ready = false;
		//this.prepareAds();

		return true;
	}

	prepareAds() {
		this.is_ready = false;
		if (!this.is_available) return;
		this.admob.banner.prepare();
	}

	setLoadSuccessCallback(caller, func) {
		if (!this.is_available) return false;
		this.load_success_callback_caller = caller;
		this.load_success_callback_func = func;
		return true;
	}

	setLoadFailCallback(caller, func) {
		if (!this.is_available) return false;
		this.load_fail_callback_caller = caller;
		this.load_fail_callback_func = func;
		return true;
	}

	show(callback_success, callback_fail) {
		if (!this.is_ready) {
			console.log("Ad is not ready");
			if (typeof(callback_fail) === "function") {
				callback_fail();
			}
			return false;
		}

		return true;
	}

	hide(callback_success, callback_fail) {
		if (!this.is_ready) {
			console.log("Ad is not ready");
			if (typeof(callback_fail) === "function") {
				callback_fail();
			}
			return false;
		}

		this.admob.banner.hide().then(callback_success, callback_fail);
		return true;
	}
}
