function scrollToElement(target, elem, duration, callback_success) {
	if (!target || !elem) return;
	if (isNaN(duration)) {
		duration = 200;
	}

	var target_top = target[0].scrollTop;
	var target_height = target[0].getBoundingClientRect().height;
	var elem_top = elem[0].getBoundingClientRect().top;
	var elem_height = elem[0].getBoundingClientRect().height;
	var scroll_top = target_top + elem_top - Math.max(target_height - elem_height, 0)/2;

	target.animate({
		scrollTop: scroll_top
	}, duration, "swing", function() {
		if (typeof(callback_success) == "function") {
			callback_success();
		}
	});
}

function scrollToTop(target, duration, callback_success) {
	target.animate({
		scrollTop: 0
	}, duration, "swing", function() {
		if (typeof(callback_success) == "function") {
			callback_success();
		}
	});
}

function wait(delay) {
	return new Promise((resolve, reject) => {
		setTimeout(resolve, delay);
	});
}

// var VERSION = "0.0.4";
// var DEBUG = true;

var IS_TOUCH_DEVICE = ("ontouchstart" in window);
var EVENTS = IS_TOUCH_DEVICE ? {
	"touchstart": "touchstart",
	"touchend": "touchend",
} : {
	"touchstart": "mousedown",
	"touchend": "mouseup",
};

var OS_TYPE = "other";
if( /(android)/i.test(navigator.userAgent) ) {
	OS_TYPE = "android";
} else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) {
	OS_TYPE = "ios";
}

var STORE_URL = {
	android: "http://www.pujia8.com/library/10675/",
	ios: "https://itunes.apple.com/cn/app/id1401196093",
	other: "",
};

var OURAPP_URL = {
	android: "https://www.pujia8.com/ads/?p=android&b=com.pujiadev.chatnovel4",
	ios: "https://itunes.apple.com/cn/developer/shanghai-ouhuang-network-technology-co-ltd/id1301127152?mt=8",
	other: "",
};
var OTHERAPP_URL = {
	"kaiikeijiban": {
		android: "http://www.pujia8.com/library/10466/",
		ios: "https://itunes.apple.com/cn/app/id1373618587",
		other: "",
	},
	"kurinukisan": {
		android: "http://www.pujia8.com/library/10622/",
		ios: "https://itunes.apple.com/cn/app/id1392374950",
		other: "",
	},
	"kanosatsu": {
		android: "http://www.pujia8.com/library/10142/",
		ios: "https://itunes.apple.com/cn/app/id1383652416",
		other: "",
	},
};

var SHARE_OPTION_NORMAL = {
	message: '#艾比#\n《怪异揭示板》团队新作，讲诉一个全新的青春科幻故事。\n\n【iPhone版】 ' + STORE_URL["ios"] + "\n\n【Android版】 " + STORE_URL["android"],
	subject: '艾比',
};

var GA_ID = "UA-120091531-1";

// var GAME_ANALYTICS_INFO = {
// 	version: VERSION,
// 	debug: DEBUG,
// 	game_key: "fa8f7c057874ba3e69f07fb7ac4e71d0",
// 	game_secret: "e74c7ae00a1c91de72fd8edc63c9bf111d5e3530",
// }

var AD_COMPONENT_INFO = {
	ios: {
		pub_id: "pub-8307811843707508",
		interstitial_id: "ca-app-pub-8307811843707508/7135281428",
		banner_id: "ca-app-pub-8307811843707508/9761444762",
		reward_id: "ca-app-pub-8307811843707508/8094824081",
	},
	android: {
		pub_id: "pub-8307811843707508",
		interstitial_id: "ca-app-pub-8307811843707508/1910874907",
		banner_id: "ca-app-pub-8307811843707508/5060207454",
		reward_id: "ca-app-pub-8307811843707508/4153894864",
	},
	other: {
		pub_id: "pub-8307811843707508",
	}
};

var FIXED_SE = {
	"say": "media/sound/se/se_say.mp3",
	"select": "media/sound/se/se_select.mp3",
	"click": "media/sound/se/se_click.m4a",
	"selectscreen": "media/sound/se/se_selectscreen.m4a",
	"menu_button_show": "media/sound/se/se_menu_button_show.m4a",
	"call_begin": "media/sound/se/se_button_call_begin.mp3",
	"call_end": "media/sound/se/se_button_call_end.mp3",
	"call_disconnect": "media/sound/se/se_call_disconnect.mp3",
	"emotion_anger": "media/sound/se/se_emotion_anger.m4a",
	"emotion_happy": "media/sound/se/se_emotion_happy.m4a",
	"emotion_inspiration": "media/sound/se/se_emotion_inspiration.m4a",
	"emotion_surprise": "media/sound/se/se_emotion_surprise.m4a",
	"emotion_sweat": "media/sound/se/se_emotion_sweat.m4a",
	"emotion_question": "media/sound/se/se_emotion_question.m4a",
	"emotion_confuse": "media/sound/se/se_emotion_confuse.m4a",
	"button": "media/sound/se/se000.m4a",
	"button_p": "media/sound/se/se_button_p.m4a",
	"button_n": "media/sound/se/se_button_n.m4a",
	"button_go": "media/sound/se/se_game_start.m4a",
	"pulldown_open": "media/sound/se/se_pulldown_open.m4a",
	"pulldown_close": "media/sound/se/se_pulldown_close.m4a",
	"game_start": "media/sound/se/se_game_start.m4a",
	"dev1": "media/sound/se/se_voice_reset.m4a",
	"dev2": "media/sound/se/se_voice_debug.m4a",
};

var EMOTIONAL_ICON_META_INFO = {
	"surprise": { volume: 0.6, duration: 1000 },
	"sweat": { volume: 0.3, duration: 1500 },
	"happy": { volume: 0.5, duration: 1500 },
	"inspiration": { volume: 0.4, duration: 1500 },
	"anger": { volume: 1, duration: 1000 },
	"question": { volume: 0.3, duration: 1000 },
	"confuse": { volume: 0.3, duration: 1000 },
};

var TIMELINE_ROOT_FILENAME = "timeline/root.csv";

var TRANSPARENT_IMAGE = "media/image/transparent.png";

var PSEUDO_BANNER_AD = "media/image/parts/kaiikeijiban_ad.png";

var CSV_HEAD_ROW = {
	"title": [
		"command",
		"value",
	],
	"person": [
		"command",
		"id",
		"name",
		"icon",
		"image_id",
	],
	"scene": [
		"command",
		"name",
		"type",
		"background",
		"atom_type",
	],
	"bgm": [
		"command",
		"filename",
		"loop_start",
		"loop_end",
	],
	"cache_image": [
		"command",
		"filename",
	],
	"chapter": [
		"command",
		"title",
		"filename",
		"extra",
	],
	"section": [
		"command",
		"id",
		"type",
		"title",
	],
	"subsection": [
		"command",
		"label_name",
		"title",
	],
};

var CSV_BODY_ROW = {
	"init": [
		"command",
		"target",
	],
	"nothing": [
		"command",
		"duration",
	],
	"say": [
		"command",
		"side",
		"person_id",
		"text",
		"write_speed",
	],
	"say_effect": [
		"command",
		"effects",
	],
	"emotion": [
		"command",
		"side",
		"person_id",
		"type",
		"next",
	],
	"attach": [
		"command",
		"side",
		"person_id",
		"filename",
		"write_speed",
	],
	"split": [
		"command",
		"text",
	],
	"narration": [
		"command",
		"action",
		"text",
		"effect",
	],
	"colorscreen": [
		"command",
		"action",
		"type",
		"text",
		"duration",
	],
	"label": [
		"command",
		"name",
		"save",
	],
	"section": [
		"command",
		"action",
		"id",
	],
	"goto": [
		"command",
		"label_name",
		"expr",
	],
	"select": [
		"command",
		"caption",
		"label_name",
	],
	"select_option": [
		"command",
		"caption",
		"expr",
		"type",
	],
	"titlescreen": [
		"command",
		"action",
		"title_type",
		"expr",
	],
	"flag": [
		"command",
		"expr",
	],
	"bgm": [
		"command",
		"filename",
		"fade_duration",
		"volume",
		"loop",
		"loop_start",
		"loop_end",
	],
	"bgm_long": [
		"command",
		"filename",
		"fade_duration",
		"volume",
		"loop",
	],
	"se": [
		"command",
		"filename",
		"volume",
	],
	"ad_interstitial": [
		"command",
		"action",
	],
	"ad_banner": [
		"command",
		"action",
		"image",
	],
	"ga_view": [
		"command",
		"screen",
	],
	"ga_event": [
		"command",
		"category",
		"action",
		"label",
		"value",
	],
	"gameover": [
		"command",
		"label_continue",
		"label_end",
	],

	"scene": [
		"command",
		"name",
	],
	"clear_timeline": [
		"command",
	],
	"dom_class": [
		"command",
		"element",
		"action",
		"class_name",
	],
	"caption": [
		"command",
		"action",
		"text",
		"effect",
	],
	"stamp": [
		"command",
		"side",
		"person_id",
		"filename",
	],
	"share": [
		"command",
	],
	"chat_login": [
		"command",
		"person_id",
	],
	"chat_logout": [
		"command",
		"person_id",
	],
	"image": [
		"command",
		"filename",
		"duration",
	],
	"image_mobile": [
		"command",
		"filename",
	],
	"callscreen": [
		"command",
		"type",
		"person_id",
		"duration",
		"expr_success",
		"expr_failed",
	],
	"main_menu": [
		"command",
		"action",
	],
	"flash": [
		"command",
	],

	"chat_log_ui": [
		"command",
		"type",
	],
	"open_link": [
		"command",
		"id",
	],

	"store": [
		"command",
		"action",
		"id",
	],

	"chapter_title": [
		"command",
		"action",
		"text1",
		"text2",
	],

	"rate_app": [
		"command",
	]
};

// cordova-plugin-analytics
class GoogleAnalyticsComponent {
	constructor(id) {
		this.id = id;
		this.start_time = new Date();
		this.analytics = undefined;

		this.is_ready = false;
		this.is_available = this.initAnalytics();
	}

	initAnalytics() {
		if (typeof(analytics) !== "object") return false;

		this.analytics = analytics;
		this.analytics.startTrackerWithId(this.id, () => {
			this.is_ready = true;
		}, () => {
			console.log("failed to init ga track");
			return false;
		});

		return true;
	}

	trackView(screen) {
		if (!this.is_ready) {
			console.log("failed trackView", screen);
		} else {
			this.analytics.trackView(screen);
		}
	}

	trackEvent(category, action, label, value) {
		if (!this.is_ready) {
			console.log("failed trackEvent", category, action, label, value);
		} else {
			this.analytics.trackEvent(category, action, label, value);
		}
	}
}

class Person {
	constructor(id, name, icon, image_id) {
		this.id = id;
		this.name = name;
		this.icon = icon;
		this.image_id = image_id;
		this.chat_status = "logout";
		this.subpersons = {};
	}

	readPersonChat(person, delay) {
		var target = $(".person_container[person_id="+person.id+"]:last-of-type .seen_icon_container");
		if (target.length <= 0) return;

		var seen_icon = $(".seen_icon[person_id="+this.id+"]");
		if (seen_icon.length <= 0) {
			seen_icon = $("<div class='seen_icon' person_id='"+this.id+"' style='background-image:url("+this.icon+")' alt='"+this.name+"'></div>");
		}

		if (this.id == person.id) {
			seen_icon.addClass("is_self");
		} else {
			seen_icon.removeClass("is_self");
		}

		setTimeout(() => {
			seen_icon.removeClass("show");
			setTimeout(() => {
				seen_icon.addClass("show");
				seen_icon.prependTo(target);
			}, 100);
		}, isNaN(delay) ? 0 : delay);
	}

	addSubPerson(id, person) {
		this.subpersons[id] = person;
	}

	getSubPerson(id) {
		var id_parsed = id.split("/");
		if (id_parsed.length > 1) {
			return this.subpersons[id_parsed[1]];
		} else {
			return this.subpersons[id_parsed[0]];
		}
	}
}

class StoryIndex {
	constructor(timeline) {
		this.timeline = timeline;
		this.chapters = [];
	}

	addChapter(chapter) {
		this.chapters.push(chapter);
	}

	addSection(section) {
		if (this.chapters.length <= 0) return;
		var chapter = this.chapters[this.chapters.length-1];
		chapter.addSection(section);
	}

	getStoryIndexElement() {
		var story_elem = $("<div class='story_index_box'></div>");
		for (var i in this.chapters) {
			var chapter_elem = this.chapters[i].getChapterElem(this.timeline);
			story_elem.append(chapter_elem);
		}

		var button_close = $("<div id='button_close_story_index' class='se_button_n'><i class='fa fa-times'></i></div>");
		button_close.on("click", function() {
			$("#screen_story_index").removeClass("show");
		})

		return [story_elem, button_close];
	}

	endAllChapters() {
		this.chapters.forEach((chapter) => {
			chapter.endAllSections(this.timeline);
		});
	}

	isEndAllChapters() {
		for (var i = 0; i < this.chapters.length; i++) {
			var chapter = this.chapters[i];
			if (chapter.extra) continue;
			if (!chapter.isEndAllSections(this.timeline)) return false;
		}
		return true;
	}
}

class Chapter {
	constructor(title, filename, extra) {
		this.title = title;
		this.filename = filename;
		this.extra = extra;

		this.sections = [];
	}

	addSection(section) {
		this.sections.push(section);
	}

	getChapterElem(timeline) {
		var chapter_elem = $("<div class='chapter_elem'></div>");
		var title_elem = $("<div class='chapter_title'>"+this.title+"</div>");
		var section_list = $("<div class='section_list' style='display: none;'></div>");
		title_elem.on("click", function() {
			section_list.slideToggle();
			if (section_list.hasClass("opened")) {
				section_list.removeClass("opened");
				timeline.playSE(FIXED_SE["pulldown_close"], 1);
			} else {
				section_list.addClass("opened");
				timeline.playSE(FIXED_SE["pulldown_open"], 1);
			}
		});
		chapter_elem.append(title_elem);
		for (var i in this.sections) {
			var section_elem = this.sections[i].getSectionElem(timeline);
			section_list.append(section_elem);
		}

		var section_num = section_list.find(".section_elem").length;
		var section_num_begin = section_list.find(".section_elem[status=begin]").length;
		var section_num_end = section_list.find(".section_elem[status=end]").length;
		if (section_num > 0) {
			var achieved_ratio = section_num_end/section_num*100;
			var achieved_ratio_elem = $("<div class='achieved_ratio'>"+Math.floor(achieved_ratio)+"%</div>");
			if (achieved_ratio >= 100) {
				achieved_ratio_elem.addClass("max");
			}
			achieved_ratio_elem.css("right", (100-achieved_ratio) + "%");
			var background_string = [
				"linear-gradient(to right,",
				"hsla(200, 80%, 35%, 1) 0%,",
				"hsla(200, 80%, 45%, 1) "+achieved_ratio+"%,",
				"hsla(200, 80%, 40%, 1) "+achieved_ratio+"%,",
				"hsla(200, 80%, 40%, 1) 100%",
				")"
			].join(" ");
			title_elem.css("background", background_string);
			title_elem.append(achieved_ratio_elem);
		}

		chapter_elem.append(section_list);
		if (section_num_begin + section_num_end > 0) {
			chapter_elem.addClass("show");
		}

		return chapter_elem;
	}

	endAllSections(timeline) {
		this.sections.forEach((section) => {
			section.endSection(timeline);
		});
	}

	isEndAllSections(timeline) {
		for (var i = 0; i < this.sections.length; i++) {
			if (!this.sections[i].isEnd(timeline)) return false;
		}
		return true;
	}
}

class Section {
	constructor(id, chapter, type, title) {
		this.id = id;
		this.chapter = chapter;
		this.title = title;
		this.type = type;
		this.label_name = chapter.filename + ":label_section_" + id;
		this.flag_name = "_section_status_" + id;
		this.subsections = [];
	}

	getSectionElem(timeline) {
		if (!this.flag_name) return;
		var section_elem = $("<div class='section_elem button_default se_button_go' type='"+this.type+"' label='"+this.label_name+"'></div>");
		var status = timeline.flags[this.flag_name];
		var title = "? ? ?";

		if (this.subsections.length && this.isEnd(timeline)) {
			section_elem.addClass("show_subsection");
		}

		var handle_section_elem_click = (elem) => {
			if ($(elem).hasClass("selected")) return;
			$(elem).addClass("selected");
			timeline.commandBlock();
			wait(500).then(() => {
				if ($(elem).hasClass("show_subsection")) {
					var dialog_options = [];

					dialog_options.push({
						caption: "本章节最初（无广告）",
						callback: function() {
							timeline.hideTitleScreen();
							$("#screen_story_index").removeClass("show");
							audio_manager.fadeOutBGMAll(5000);
							$(elem).removeClass("selected");
							timeline.gotoLabel($(elem).attr("label")).then(() => {
								timeline.commandDone(4000);
							});
						},
					});
					this.subsections.forEach(function(subsection) {
						dialog_options.push({
							caption: subsection.title,
							callback: function() {
								timeline.showRewardAd(()=> {
									timeline.hideTitleScreen();
									$("#screen_story_index").removeClass("show");
									audio_manager.fadeOutBGMAll(5000);
									$(elem).removeClass("selected");
									timeline.gotoLabel(subsection.label_name).then(() => {
										timeline.commandDone(4000);
										wait(4000).then(() => {
											$("#main_menu_container").addClass("show");
										});
									});
								}, () => {
									$(elem).removeClass("selected");
								});
							}
						});
					});
					dialog_options.push({
						caption: "取消",
						type: "sub_option",
						callback: function() {
							$(elem).removeClass("selected");
						},
					});
					timeline.showDialog("要从哪里开始游戏？<hr>观看广告可以从章节中途<br>分歧前开始", dialog_options);
				} else {
					timeline.hideTitleScreen();
					$("#screen_story_index").removeClass("show");
					audio_manager.fadeOutBGMAll(5000);
					$(elem).removeClass("selected");
					timeline.gotoLabel($(elem).attr("label")).then(() => {
						timeline.commandDone(4000);
					});
				}
			});
		};

		switch (status) {
			case "begin":
			title = "（进行中）";
			section_elem.on("click", function() {
				handle_section_elem_click(this);
				timeline.playSE(FIXED_SE["game_start"], 1);
			});
			break;

			case "end":
			title = this.title;
			section_elem.on("click", function() {
				handle_section_elem_click(this);
				timeline.playSE(FIXED_SE["game_start"], 1);
			});
			break;

			default:
		}
		section_elem.attr("status", status);

		section_elem.html(title);

		return section_elem;
	}

	addSubSection(subsection) {
		this.subsections.push(subsection);
	}

	endSection(timeline) {
		timeline.flags[this.flag_name] = "end";
	}

	isEnd(timeline) {
		return (timeline.flags[this.flag_name] == "end");
	}
}

class SubSection {
	constructor(label_name, section, title) {
		this.section = section;
		this.title = title;

		this.label_name = undefined;
		if (label_name.indexOf(":") < 0 && section.chapter) {
			this.label_name = section.chapter.filename + ":" + label_name;
		} else {
			this.label_name = label_name;
		}
	}
}

class Timeline {
	constructor() {
		this.is_ready = false;
		this.chat = $("#chat_window .f2f_timeline");
		this.mobile_chat = $("#chat_window .mobile_chat_timeline");
		this.timeline_name = "";
		this.counter = 0;
		this.waiting = false;
		this.timeline_script = [];
		this.flags = {};
		this.label_map = {};
		this.scene = undefined;
		this.scenes = {};
		this.persons = {};
		this.timers = {};
		this.timer_start = {};
		this.last_label = "";
		this.interstitial_ad_component = new AdComponent(AD_COMPONENT_INFO);
		this.reward_ad_component = new RewardAdComponent(AD_COMPONENT_INFO);
		this.banner_ad_component = undefined;
		this.ga_component = undefined;
		this.loaded_images = {};
		this.story_index = undefined;
		this.say_effects = "";

		this.loadData();

		this.interstitial_ad_component.initAds();
		this.reward_ad_component.initAds();

		var self = this;
		var p_touchstart, p_touchend;
		$("#chat_window").on(EVENTS["touchend"], function(evt) {
			if (!p_touchstart) return;
			if (IS_TOUCH_DEVICE) {
				p_touchend = {
					x: evt.changedTouches[0].clientX,
					y: evt.changedTouches[0].clientY,
				};
			} else {
				p_touchend = {
					x: evt.clientX,
					y: evt.clientY,
				};
			}
			var d = Math.sqrt(Math.pow(p_touchend.x - p_touchstart.x, 2) + Math.pow(p_touchend.y - p_touchstart.y, 2));
			p_touchend = undefined;
			p_touchstart = undefined;
			if (d > 20) return;

			self.forwardTimeline();
		});

		$("#chat_window").on(EVENTS["touchstart"], function(evt) {
			if (IS_TOUCH_DEVICE) {
				p_touchstart = {
					x: evt.changedTouches[0].clientX,
					y: evt.changedTouches[0].clientY,
				};
			} else {
				p_touchstart = {
					x: evt.clientX,
					y: evt.clientY,
				};
			}
		});

		var scroll_hanldler = (evt, target) => {
			var pos = this.getScrollPos($(target));

			if (pos === undefined) {
				return;
			} else if (pos <= 0) {
				this.showOldContent($(target));
			} else if (pos >= 1) {
				this.showNewContent($(target));
			}
		};
		this.chat.on("scroll", function(evt) {
			scroll_hanldler(evt, this);
		});
		this.mobile_chat.on("scroll", function(evt) {
			scroll_hanldler(evt, this);
		});
	}

	getTextFile(filename) {
		return new Promise(function(resolve, reject) {
			if (!filename) {
				reject();
				return;
			}

			var xhr = new XMLHttpRequest();
			xhr.open("GET", filename, true);
			xhr.responseType = "text";
			xhr.onload = function() {
				resolve(xhr.responseText);
			};
			xhr.onerror = function() {
				reject(xhr.status);
			};
			xhr.onabort = function() {
				reject(xhr.status);
			};
			xhr.ontimeout = function() {
				reject(xhr.status);
			};
			xhr.send();
		});
	}

	setAdComponent(interstitial_ad_component) {
		if (!interstitial_ad_component) return;
		this.interstitial_ad_component = interstitial_ad_component;
	}

	setRewardAdComponent(reward_ad_component) {
		if (!reward_ad_component) return;
		this.reward_ad_component = reward_ad_component;
	}

	setBannerAdComponent(banner_ad_component) {
		if (!banner_ad_component) return;
		this.banner_ad_component = banner_ad_component;
	}

	setGAComponent(ga_component) {
		if (!ga_component) return;
		this.ga_component = ga_component;
	}

	// setGameAnalyticsManager(gameanalytics_manager) {
	// 	if (!gameanalytics_manager) return;
	// 	this.gameanalytics_manager = gameanalytics_manager;
	// }

	setPerson(id, person) {
		this.persons[id] = person;
	}

	getPerson(id) {
		var id_parsed = id.split("/");
		if (id_parsed.length > 1) {
			var person = this.persons[id_parsed[0]];
			if (!person) return;
			return person.getSubPerson(id_parsed[1]);
		} else {
			return this.persons[id];
		}
	}

	importTimelineFromCSV(filename) {
		return new Promise((resolve, reject) => {
			if (!filename) {
				reject();
				return;
			}

			var parse_csv_text = (csv_str) => {
				var lines = csv_str.split("\n");
				var mode = "unknown";

				var parseLineFuncs = {
					"head": this.parseCSVHeadLine,
					"body": this.parseCSVBodyLine,
				};

				while (lines.length > 0) {
					var line = lines.shift().split(",");
					if (line.length < 1) continue;
					if (line.length == 1 && line[0] == "") continue;

					for (var j = 0; j < line.length; j++) {
						line[j] = line[j].trim();
					}

					if (line.length > 0 && line[0].indexOf("[") == 0) {
						switch (line[0]) {
							case "[head]":
							mode = "head";
							break;

							case "[body]":
							mode = "body";
							break;

							default:
							mode = "unknown";
							break;
						}
						continue;
					}

					if (typeof(parseLineFuncs[mode]) == "function") {
						parseLineFuncs[mode].call(this, line);
					}
				}
			}

			this.getTextFile(filename).then((content) => {
				this.timeline_script = [];
				this.label_map = {};
				this.persons = {};
				image_manager.releaseImages();
				this.initTimeline();
				this.timeline_name = filename;
				this.story_index = new StoryIndex(this);
				parse_csv_text(content);
				this.is_ready = true;
				resolve();
			}).catch((status) => {
				console.error("failed to get file", filename);
				console.error(status);
				this.is_ready = false;
				reject();
			});
		});
	}

	parseCSVHeadLine(line) {
		if (line.length < 1 || Object.keys(CSV_HEAD_ROW).indexOf(line[0]) < 0) {
			return;
		}

		var parsed = {};
		var command = line[0];
		for (var j = 0; j < CSV_HEAD_ROW[command].length; j++) {
			if (line.length <= j) break;
			parsed[CSV_HEAD_ROW[command][j]] = (line.length > j) ? line[j] : undefined;
		}

		if (!parsed) return;

		var last_chapter, last_section;
		switch (parsed.command) {
			case "title":
			this.title = parsed.value;
			break;

			case "person":
			var id_parsed = parsed.id.split("/");
			if (id_parsed.length > 1) {
				var person = this.getPerson(id_parsed[0]);
				if (!person) {
					console.error("cannot add subperson", parsed.id);
				} else {
					person.addSubPerson(id_parsed[1], new Person(id_parsed[0], parsed.name, parsed.icon, parsed.image_id));
				}
			} else {
				this.setPerson(parsed.id, new Person(parsed.id, parsed.name, parsed.icon, parsed.image_id));
			}
			break;

			case "scene":
			this.scenes[parsed.name] = {
				name: parsed.name,
				type: parsed.type,
				background: parsed.background,
				atom_type: parsed.atom_type,
			};
			break;

			case "bgm":
			audio_manager.setBGMMetaInfo({
				"id": parsed.filename,
				"loop_start": parsed.loop_start,
				"loop_end": parsed.loop_end,
			});
			break;

			case "cache_image":
			image_manager.loadImage(parsed.filename);
			break;

			case "chapter":
			last_chapter = new Chapter(parsed.title, parsed.filename, parsed.extra);
			this.story_index.addChapter(last_chapter);
			break;

			case "section":
			if (this.story_index.chapters.length <= 0) break;
			last_chapter = this.story_index.chapters[this.story_index.chapters.length-1];
			if (last_chapter) {
				last_chapter.addSection(new Section(parsed.id, last_chapter, parsed.type, parsed.title));
			}
			break;

			case "subsection":
			if (this.story_index.chapters.length <= 0) break;
			last_chapter = this.story_index.chapters[this.story_index.chapters.length-1];
			if (last_chapter) {
				last_section = last_chapter.sections[last_chapter.sections.length-1];
				if (last_section) {
					last_section.addSubSection(new SubSection(parsed.label_name, last_section, parsed.title));
				}
			}
			break;

			default:
		}
	}

	parseCSVBodyLine(line) {
		if (line.length < 1) return;

		var parsed = {};
		var command_split = line[0].split("@");
		var command = command_split[0];
		var do_next_duration = undefined;
		if ((command_split.length > 1) && !isNaN(command_split[1])) {
			do_next_duration = command_split[1];
		}

		if (Object.keys(CSV_BODY_ROW).indexOf(command) < 0) return;

		line[0] = command;
		for (var j = 0; j < CSV_BODY_ROW[command].length; j++) {
			if (line.length <= j) break;
			parsed[CSV_BODY_ROW[command][j]] = (line.length > j) ? line[j] : undefined;
		}
		parsed["_line_number"] = this.timeline_script.length;
		parsed["_do_next"] = do_next_duration;
		this.timeline_script.push(parsed);

		// map label
		if (parsed.command == "label") {
			if (isNaN(this.label_map[parsed.name])) {
				this.label_map[parsed.name] = this.timeline_script.length - 1;
			} else {
				console.error("label duplicated: ", parsed.name, this.timeline_script.length - 1);
			}
		}
		if ((parsed.command == "section") && (parsed.action == "begin")) {
			var label_name = "label_section_" + parsed.id;
			if (isNaN(this.label_map[label_name])) {
				this.label_map[label_name] = this.timeline_script.length - 1;
			} else {
				console.error("label duplicated: ", label_name, this.timeline_script.length - 1);
			}
		}
	}

	isValidScriptPart(script_part, command) {
		if (command == script_part.command) {
			return true;
		}
		return false;
	}

	showInfoTip(text) {
		var info_tip = $("#info_tip");
		info_tip.html(text);
		info_tip.addClass("show");
		wait(2000).then(() => {
			info_tip.removeClass("show");
		});
	}

	replaceFlagStr(str) {
		if (!str) return "";

		// 文字列中のフラグ識別子 %{flag_name} をフラグの値で置き換える
		// flags["hoge"] == "xxx", flags["foo"] == "yyy" の場合、
		// replaceFlagStr("aaa%{hoge}bbb%{foo}") == "aaaxxxbbbyyy"
		return str.replace(/%{([^%{}]+)}/g, (match, capture) => {
			return (this.flags[capture]) ? this.flags[capture] : "";
		});
	}

	setFlag(expr) {
		if (!expr) return false;

		var key_val = expr.split("=");
		var key = (key_val.length > 0) ? key_val[0].trim() : undefined;
		var val = (key && key_val.length > 1) ? key_val[1].trim() : undefined;

		if (val === undefined) {
			return false;
		}

		if (this.isCalc(val)) {
			val = this.doCalc(val);
		} else if (this.isFlagName(val)) {
			val = this.flags[val];
		} else {
			val = this.toValue(val);
		}

		if (key) {
			this.flags[key] = val;
		}
		return true;
	}

	doCalc(str) {
		var operators = [
			{
				key: "+",
				func: function(l, r) { return l + r },
			},
			{
				key: "-",
				func: function(l, r) { return l - r },
			},
			{
				key: "*",
				func: function(l, r) { return l * r },
			},
			{
				key: "/",
				func: function(l, r) { return l / r },
			},
		];

		var operator, func, expr_pair, l, r;
		for (var i = 0; i < operators.length; i++) {
			operator = operators[i];
			if (str.indexOf(operator.key) >= 0) {
				func = operator.func;
				expr_pair = str.split(operator.key);
				if (expr_pair.length < 2) break;

				l = (this.isFlagName(expr_pair[0])) ? this.flags[expr_pair[0]] : this.toValue(expr_pair[0]);
				r = (this.isFlagName(expr_pair[1])) ? this.flags[expr_pair[1]] : this.toValue(expr_pair[1]);
				return func(l, r);
			}
		}
	}

	isCalc(str) {
		if (str.indexOf("+") >= 0) return true;
		if (str.indexOf("-") >= 0) return true;
		if (str.indexOf("*") >= 0) return true;
		if (str.indexOf("/") >= 0) return true;
		return false;
	}

	isFlagName(str) {
		if (!isNaN(str)) return false; // this is a number
		if ((str.length > 1) && (str[0] == "\"") && (str[str.length-1] == "\"")) return false; // this is a string
		return true;
	}

	toValue(str) {
		if ((str.length > 1) && (str[0] == "\"") && (str[str.length-1] == "\"")) {
			return str.slice(1, -1);
		} else if (!isNaN(str)) {
			return Number(str);
		}
		return str;
	}

	isMatchFlag(expr) {
		var operators = [
			{
				key: "==",
				func: function(l, r) { return (l == r) },
			},
			{
				key: ">=",
				func: function(l, r) { return (l >= r) },
			},
			{
				key: "<=",
				func: function(l, r) { return (l <= r) },
			},
			{
				key: "!=",
				func: function(l, r) { return (l != r) },
			},
			{
				key: ">",
				func: function(l, r) { return (l > r) },
			},
			{
				key: "<",
				func: function(l, r) { return (l < r) },
			},
		];

		var operator, func, expr_pair, l, r;
		for (var i = 0; i < operators.length; i++) {
			operator = operators[i];
			if (expr.indexOf(operator.key) >= 0) {
				func = operator.func;
				expr_pair = expr.split(operator.key);
				if (expr_pair.length < 2) break;

				l = (this.isFlagName(expr_pair[0])) ? this.flags[expr_pair[0]] : this.toValue(expr_pair[0]);
				r = (this.isFlagName(expr_pair[1])) ? this.flags[expr_pair[1]] : this.toValue(expr_pair[1]);
				if (typeof(func) == "function") return func(l, r);
				break;
			}
		}

		if (this.flags[expr]) return true;

		return false;
	}

	gotoLabel(label_name) {
		return new Promise((resolve, reject) => {
			var filename, target_label, counter;
			if (label_name === undefined || label_name === null) {
				filename = TIMELINE_ROOT_FILENAME;
				target_label = "";
			} else if (label_name === "") {
				counter = 0;
			} else if (label_name.indexOf(":") >= 0) {
				filename = label_name.split(":")[0];
				target_label = label_name.split(":")[1];
			} else if (this.label_map[label_name] !== undefined) {
				counter = this.label_map[label_name];
			} else {
				// unknown label
				filename = TIMELINE_ROOT_FILENAME;
				target_label = "";
			}

			if (counter === undefined) {
				this.importTimelineFromCSV(filename).then(() => {
					this.gotoLabel(target_label).then(resolve).catch(reject);
				}).catch(() => {
					reject();
				});
			} else {
				this.counter = counter;
				resolve();
			}
		});
	}

	gotoTitleScreen() {
		this.gotoLabel(TIMELINE_ROOT_FILENAME + ":label_begin").then(() => {
			audio_manager.fadeOutBGMAll(2000);
			this.changeMobileFramePos(undefined, "hidden");
			this.clearTimeline();
			this.commandDone(0);
		});
	}

	showNextIndicator() {
		$("#go_next_indicator").addClass("show");
	}

	hideNextIndicator() {
		$("#go_next_indicator").removeClass("show");
	}

	commandBlocking() {
		return this.waiting;
	}

	commandBlock() {
		this.waiting = true;
		this.hideNextIndicator();
	}

	commandDone(time) {
		var next_duration = isNaN(time) ? -1 : Number(time);
		if (next_duration >= 0) {
			if (this.timers["_command_done"]) {
				clearTimeout(this.timers["_command_done"]);
				delete this.timers["_command_done"];
			}
			this.timers["_command_done"] = setTimeout(() => {
				this.waiting = false;
				this.showNextIndicator();
				this.forwardTimeline();
			}, next_duration);
		} else {
			this.waiting = false;
			this.showNextIndicator();
		}
	}

	setBlockingAction(callback) {
		if (typeof(callback) == "function") {
			this.blocking_action = callback;
		}
	}

	doBlockingAction() {
		if (this.blocking_action) {
			this.blocking_action();
			this.blocking_action = undefined;
		}
	}

	handleCommandInit(script_part) {
		switch (script_part.target) {
			case "timeline":
			this.initTimeline();
			break;
		}
		this.commandDone(0);
		return false;
	}

	handleCommandNothing(script_part) {
		var duration = script_part.duration;
		if (!isNaN(script_part._do_next)) {
			duration = script_part._do_next;
		}
		this.commandDone(duration);
	}

	handleCommandSay(script_part) {
		var target_chat = (this.scene.type == "chat") ? this.mobile_chat : this.chat;
		var person = this.getPerson(script_part.person_id);
		if (!person) {
			console.error("unknown person", script_part.person_id);
			this.commandDone(0);
			return false;
		}

		var person_container_elem = $("<div class='timeline_object person_container "+script_part.side+"_person_container' person_id='"+person.id+"'></div>");
		var person_icon_elem = $("<div class='person_icon' style='background-image:url("+person.icon+")' alt='"+person.name+"'></div>");
		var person_name_elem = $("<div class='person_name'>"+person.name+"</div>");
		var chat_balloon = $("<div class='chat_balloon'></div>");
		var scene = this.scene;
		if (scene) {
			person_container_elem.addClass("conv_type_" + scene.type);
		}
		var last_person_id = target_chat.find(".person_container:last-of-type").attr("person_id");
		if (person.id == last_person_id) {
			person_container_elem.addClass("continued");
		}

		person_container_elem.append(person_icon_elem);
		person_container_elem.append(person_name_elem);
		person_container_elem.append(chat_balloon);

		person.chat_status = "login";

		var write_speed = 1;
		if (!script_part.write_speed || isNaN(script_part.write_speed)) {
			write_speed = 1;
		} else if (script_part.write_speed > 0) {
			write_speed = script_part.write_speed;
		} else {
			write_speed = -1;
		}
		if (scene.type == "f2f" || scene.type == "f2p") {
			if (write_speed <= 0) {
				write_speed = 1;
			}
			$(".chat_stage_person").removeClass("focused");
			var chat_stage_person_target = $(".chat_stage_person_"+script_part.side);
			chat_stage_person_target.addClass("show");
			chat_stage_person_target.addClass("focused");
			chat_stage_person_target.attr("person_id", person.id);
			chat_stage_person_target.attr("image_id", person.image_id);
			if (script_part.text) {
				var char_elems = [];
				for (var i = 0; i < script_part.text.length; i++) {
					var char_elem = $("<span style='transition-delay: "+50/write_speed*i+"ms;'>"+script_part.text[i]+"</span>");
					char_elems.push(char_elem);
					chat_balloon.append(char_elem);
				}

				this.playSE(FIXED_SE["select"], 0.3);

				var done_timer = undefined;
				var done_timer2 = undefined;

				// overlap to next say
				var overlap = false;
				if (this.say_effects && this.say_effects.split(" ").indexOf("overlap") >= 0) {
					overlap = true;
				}

				if (overlap) {
					done_timer = setTimeout(() => {
						done_timer = undefined;
						this.commandDone(0);
					}, 50/write_speed*script_part.text.length * 0.8);
				} else {
					done_timer = setTimeout(() => {
						done_timer = undefined;
						scrollToElement(target_chat, person_container_elem);
						done_timer2 = setTimeout(() => {
							this.commandDone(script_part._do_next);
						}, 200);
					}, 50/write_speed*script_part.text.length);
				}

				if (this.say_effects) {
					person_container_elem.addClass(this.say_effects);
					this.say_effects = "";
				}

				target_chat.append(person_container_elem);
				wait(0).then(() => {
					chat_balloon.find("span").css("visibility", "inherit");
				});
				if (!script_part._do_next && !overlap) {
					this.setBlockingAction(() => {
						if (!done_timer) return;
						clearTimeout(done_timer2);
						clearTimeout(done_timer);
						chat_balloon.find("span").remove();
						for (var i = 0; i < script_part.text.length; i++) {
							var char_elem = $("<span style='visibility: inherit;'>"+script_part.text[i]+"</span>");
							char_elems.push(char_elem);
							chat_balloon.append(char_elem);
						}
						done_timer2 = setTimeout(() => {
							this.commandDone();
						}, 200);
					});
				}
				scrollToElement(target_chat, person_container_elem);
			} else {
				this.commandDone(script_part._do_next);
			}
		} else {
			if (write_speed <= 0) {
				chat_balloon.html(script_part.text);
				var login_persons = this.getPersonsChatLogin();
				for (var i in login_persons) {
					login_persons[i].readPersonChat(person, 0);
				}
				target_chat.append(person_container_elem);
				this.commandDone(0);
				return false;
			} else {
				var seen_icon_container = $("<div class='seen_icon_container'></div>");
				person_container_elem.append(seen_icon_container);
				chat_balloon.html("<i class='fa fa-spinner fa-spin'></i>");
				var write_duration = (script_part.text) ? script_part.text.length * 50 / write_speed : 1000 / write_speed;
				var done_timer2 = undefined;
				var done_timer = setTimeout(() => {
					done_timer = undefined;
					if (!script_part.text) {
						person_container_elem.remove();
						this.commandDone(script_part._do_next);
					} else {
						this.playSE(FIXED_SE["say"], 0.3);
						chat_balloon.html(script_part.text);
						scrollToElement(target_chat, person_container_elem);

						done_timer2 = setTimeout(() => {
							this.readPersonChatAll(person);
							this.commandDone(script_part._do_next);
						}, 200);
					}
				}, write_duration);
				target_chat.append(person_container_elem);
				if (!script_part._do_next) {
					this.setBlockingAction(() => {
						if (!done_timer) return;
						clearTimeout(done_timer);
						clearTimeout(done_timer2);
						if (!script_part.text) {
							person_container_elem.remove();
							this.commandDone();
						} else {
							this.playSE(FIXED_SE["say"], 0.3);
							chat_balloon.html(script_part.text);
							scrollToElement(target_chat, person_container_elem);

							done_timer2 = setTimeout(() => {
								this.readPersonChatAll(person);
								this.commandDone();
							}, 200);
						}
					});
				}
				scrollToElement(target_chat, person_container_elem);
			}
		}
	}

	handleCommandSayEffect(script_part) {
		if (!script_part.effects) {
			this.say_effects = "";
		} else {
			this.say_effects = script_part.effects;
		}

		this.commandDone(0);
		return false;
	}

	handleCommandEmotion(script_part) {
		var person = this.getPerson(script_part.person_id);
		if (!person) {
			console.error("unknown person", script_part.person_id);
			this.commandDone(0);
			return false;
		}

		var chat_stage_person_elem = $(".chat_stage_person_"+script_part.side);
		if (chat_stage_person_elem.length < 1) {
			this.commandDone(0);
			return false;
		}

		$(".chat_stage_person").removeClass("focused");
		chat_stage_person_elem.addClass("show");
		chat_stage_person_elem.addClass("focused");
		chat_stage_person_elem.attr("image_id", person.image_id);

		var emotional_icon_elem;
		if (script_part.side == "right") {
			emotional_icon_elem = $(".emotional_icon_container .emotional_icon_right");
		} else if (script_part.side == "left") {
			emotional_icon_elem = $(".emotional_icon_container .emotional_icon_left");
		}
		if (!emotional_icon_elem) {
			this.commandDone(0);
			return false;
		}

		var meta_info = EMOTIONAL_ICON_META_INFO[script_part.type];
		if (!meta_info) {
			this.commandDone(0);
			return false;
		}

		emotional_icon_elem.attr("type", script_part.type);
		var se_filename = FIXED_SE["emotion_"+script_part.type];
		if (se_filename) {
			this.playSE(se_filename, meta_info.volume);
		}

		var duration = meta_info.duration ? meta_info.duration : 1000;
		if (script_part.next == "true") {
			setTimeout(() => {
				emotional_icon_elem.removeAttr("type");
			}, duration);
			this.commandDone(0);
			return false;
		} else {
			this.chat.addClass("show_emotional_icon");
			setTimeout(() => {
				emotional_icon_elem.removeAttr("type");
				this.chat.removeClass("show_emotional_icon");
			}, duration);
			this.commandDone(duration);
		}
		return false;
	}

	handleCommandAttach(script_part) {
		var target_chat = (this.scene.type == "f2f") ? this.chat : this.mobile_chat;
		var person = this.getPerson(script_part.person_id);
		if (!person) {
			console.error("unknown person", script_part.person_id);
			this.commandDone(0);
			return false;
		}
		if (!script_part.filename) {
			this.commandDone(0);
			return false;
		}

		var person_container_elem = $("<div class='timeline_object person_container "+script_part.side+"_person_container' person_id='"+person.id+"'></div>");
		var person_icon_elem = $("<div class='person_icon' style='background-image:url("+person.icon+")' alt='"+person.name+"'></div>");
		var chat_balloon = $("<div class='chat_balloon'></div>");
		var seen_icon_container = $("<div class='seen_icon_container'></div>");
		var attached_image = $("<img class='attached_image' />")
		var scene = this.scene;
		if (scene) {
			person_container_elem.addClass("conv_type_" + scene.type);
		}
		var last_person_id = target_chat.find(".person_container:last-of-type").attr("person_id");
		if (person.id == last_person_id) {
			person_container_elem.addClass("continued");
		}

		person_container_elem.append(person_icon_elem);
		person_container_elem.append(chat_balloon);
		person_container_elem.append(seen_icon_container);

		person.chat_status = "login";

		var write_speed = 1;
		if (!script_part.write_speed || isNaN(script_part.write_speed)) {
			write_speed = 1;
		} else if (script_part.write_speed > 0) {
			write_speed = script_part.write_speed;
		} else {
			write_speed = -1;
		}

		var loading_message = "正在接收图片";
		if (script_part.side == "right") {
			loading_message = "正在发送图片";
		}

		if (write_speed <= 0) {
			attached_image.attr("src", script_part.filename);
			chat_balloon.html("");
			chat_balloon.append(attached_image);
			var login_persons = this.getPersonsChatLogin();
			for (var i in login_persons) {
				login_persons[i].readPersonChat(person, 0);
			}
			target_chat.append(person_container_elem);
			wait(200).then(() => {
				scrollToElement(target_chat, person_container_elem);
				this.commandDone(script_part._do_next);
			});
			return false;
		} else {
			chat_balloon.html("<i class='fa fa-spinner fa-spin'></i> <div class='chat_balloon_loading_message'>" + loading_message + "</div>");
			setTimeout(() => {
				attached_image.on("load", () => {
					scrollToElement(target_chat, person_container_elem);
				});
				attached_image.attr("src", script_part.filename);
				chat_balloon.html("");
				chat_balloon.append(attached_image);
				scrollToElement(target_chat, person_container_elem);
				this.playSE(FIXED_SE["say"], 0.3);
				setTimeout(() => {
					this.readPersonChatAll(person);
					this.commandDone(script_part._do_next);
				}, 200);
			}, 3000 / write_speed);

			target_chat.append(person_container_elem);
			scrollToElement(target_chat, person_container_elem);
		}

		this.changeMobileFramePos(undefined, "fullscreen");
	}

	handleCommandStamp(script_part) {
		var target_chat = (this.scene.type == "f2f") ? this.chat : this.mobile_chat;
		var person = this.getPerson(script_part.person_id);
		if (!person) {
			console.error("unknown person", script_part.person_id);
			this.commandDone(0);
			return false;
		}
		if (!script_part.filename) {
			this.commandDone(0);
			return false;
		}

		var person_container_elem = $("<div class='timeline_object person_container "+script_part.side+"_person_container' person_id='"+person.id+"'></div>");
		var person_icon_elem = $("<div class='person_icon' style='background-image:url("+person.icon+")' alt='"+person.name+"'></div>");
		var chat_balloon = $("<div class='chat_balloon stamp_balloon'></div>");
		var seen_icon_container = $("<div class='seen_icon_container'></div>");
		var stamp_image = $("<img class='stamp_image' />")
		var scene = this.scene;
		if (scene) {
			person_container_elem.addClass("conv_type_" + scene.type);
		}
		var last_person_id = target_chat.find(".person_container:last-of-type").attr("person_id");
		if (person.id == last_person_id) {
			person_container_elem.addClass("continued");
		}

		person_container_elem.append(person_icon_elem);
		person_container_elem.append(chat_balloon);
		person_container_elem.append(seen_icon_container);

		person.chat_status = "login";

		chat_balloon.html("<i class='fa fa-spinner fa-spin'></i>");

		// stamp_image.on("load", () => {
		// 	scrollToElement(target_chat, person_container_elem);
		// });
		stamp_image.attr("src", script_part.filename);
		chat_balloon.html("");
		setTimeout(() => {
			chat_balloon.append(stamp_image);
			this.playSE(FIXED_SE["say"], 0.3);

			setTimeout(() => {
				this.readPersonChatAll(person);
				this.commandDone();
			}, 200);
			target_chat.append(person_container_elem);
			scrollToElement(target_chat, person_container_elem);
		}, 400);
	}

	handleCommandSplit(script_part) {
		var target_chat = (this.scene.type == "f2f") ? this.chat : this.mobile_chat;
		var split_elem = $("<div class='timeline_object timeline_splitter'></div>");
		var scene = this.scene;
		if (scene) {
			split_elem.addClass("conv_type_" + scene.type);
		}

		split_elem.html(script_part.text);

		target_chat.append(split_elem);
		scrollToElement(target_chat, split_elem);
		this.commandDone(1000);
		return false;
	}

	handleCommandNarration(script_part) {
		var narration = $("#narration");
		var narration_text = $("#narration").find(".narration_text");

		switch(script_part.action) {
			case "show":
			if (!script_part.text) return true;

			var showText = () => {
				narration.removeClass("white rgb serious");
				if (script_part.effect) {
					narration.addClass(script_part.effect);
				}

				narration_text.html(script_part.text);
				narration_text.addClass("show");
				setTimeout(() => {
					this.commandDone(script_part._do_next);
				}, 500);
			};

			if (narration_text.hasClass("show")) {
				narration_text.removeClass("show");
				setTimeout(() => {
					showText();
				}, 500);
			} else {
				showText();
			}

			$("#main_menu_container").removeClass("show");
			narration.addClass("show");
			break;

			case "hide":
			narration_text.removeClass("show");
			narration.removeClass("show");
			setTimeout(() => {
				narration_text.html("");
				narration.removeClass("rgb white");
			}, 1000);
			$("#main_menu_container").addClass("show");
			this.commandDone(1000);
			break;
		}
	}

	handleCommandColorScreen(script_part) {
		var colorscreen = $("#colorscreen");

		var duration = 2000;
		if (!isNaN(script_part.duration)) {
			duration = script_part.duration;
		}

		switch (script_part.action) {
			case "show":
			if (script_part.type) {
				colorscreen.attr("type", script_part.type);
			} else {
				colorscreen.removeAttr("type");
			}

			if (script_part.text) {
				colorscreen.find(".colorscreen_content").html(script_part.text);
			} else {
				colorscreen.find(".colorscreen_content").html("");
			}
			colorscreen.css("transition-duration", duration + "ms");
			colorscreen.addClass("show");

			wait(duration).then(() => {
				this.commandDone(script_part._do_next);
			});
			break;

			case "hide":
			colorscreen.css("transition-duration", duration + "ms");
			colorscreen.removeClass("show");
			wait(duration).then(() => {
				this.commandDone(0);
			});
			break;

			default:
			this.commandDone(0);
		}

		return false;
	}

	handleCommandLabel(script_part) {
		this.last_label = this.timeline_name + ":" + script_part.name;
		if (script_part.save == "true") {
			this.saveData();
		}
		this.commandDone(0);
		return false;
	}

	handleCommandSection(script_part) {
		var flag_name = "_section_status_" + script_part.id;
		var label_name = "label_section_" + script_part.id;

		switch(script_part.action) {
			case "begin":
			$("#main_menu_container").addClass("show");
			if (this.flags[flag_name] != "end") {
				this.flags[flag_name] = "begin";
			}
			this.last_label = this.timeline_name + ":" + label_name;
			this.saveData();
			// this.gameanalytics_manager.progressionEvent("start", "section " + script_part.id);
			break;

			case "end":
			if (this.flags[flag_name] == "begin") {
				var point_name = "section_" + script_part.id;
				this.flags[flag_name] = "end";
				this.ga_component.trackEvent("point", "section", point_name);
			}
			this.last_label = TIMELINE_ROOT_FILENAME + ":label_begin";
			this.saveData();
			// this.gameanalytics_manager.progressionEvent("complete", "section " + script_part.id);
			break;

			case "touch":
			if (this.flags[flag_name] != "end") {
				this.flags[flag_name] = "begin";
			}
			this.saveData();
			break;
		}
		this.commandDone(0);
		return false;
	}

	handleCommandGoto(script_part) {
		if (!this.isValidScriptPart(script_part, "goto")) {
			this.commandDone(0);
			return false;
		}

		if (script_part.expr === undefined || script_part.expr === "" || this.isMatchFlag(script_part.expr)) {
			this.gotoLabel(script_part.label_name).then(() => {
				this.commandDone(0);
			}).catch(() => {
				this.commandDone(0);
			});
			return false;
		}

		this.commandDone(0);
		return false;
	}

	handleCommandSelect(script_part) {
		var caption_text = this.replaceFlagStr(script_part.caption);
		var select_screen = $("#select_screen");
		var select_screen_content = select_screen.find(".select_screen_content");
		select_screen_content.html("");
		var caption_elem = $("<div class='caption'>"+caption_text+"</div>");
		var list_elem = $("<div></div>");

		this.counter++;
		var has_option = false;
		while (!this.isEndOfScript()) {
			var status = this.handleCommandSelectOption(this.getScriptPart(), list_elem);
			if (status == "is_not_select_option") break;
			if (status == "ok") has_option = true;
		}
		if (!has_option && script_part.label_name) {
			this.gotoLabel(script_part.label_name).then(() => {
				this.commandDone(0);
			});
			return;
		}

		if (caption_text) {
			select_screen_content.append(caption_elem);
		}
		select_screen_content.append(list_elem);

		this.playSE(FIXED_SE["selectscreen"]);
		select_screen.addClass("show");
	}

	handleCommandSelectOption(script_part, list_elem) {
		var status = "ok";
		if (!this.isValidScriptPart(script_part, "select_option")) {
			this.counter--;
			status = "is_not_select_option";
			return status;
		}

		var select_option_flag_name = "@select_option_"+script_part["_line_number"];

		var option_elem = $("<button class='button_default se_button disabled'>"+script_part.caption+"</button>")
		option_elem.attr("type", script_part.type);
		if (script_part.type == "disabled") {
			status = "cannot_select";
		}
		if (this.isMatchFlag(select_option_flag_name+"==1")) {
			// already selected before
			option_elem.addClass("cannot_select");
			status = "cannot_select";
		}
		var self = this;
		option_elem.on("click", function() {
			if ($(this).hasClass("disabled")) {
				return;
			}
			list_elem.find(".button_default").addClass("disabled");
			$(this).addClass("selected");
			self.setFlag(select_option_flag_name+"=1");
			setTimeout(() => {
				if (script_part.expr && !self.setFlag(script_part.expr)) {
					self.gotoLabel(script_part.expr);
				}
				$("#select_screen").removeClass("show");
				self.commandDone(0);
			}, 1000);
		});
		var count = list_elem.find(".button_default").length;
		setTimeout(() => {
			if (list_elem.find(".button_default.selected").length > 0) return;
			option_elem.removeClass("disabled");
			if (status == "ok") audio_manager.playSE(FIXED_SE["menu_button_show"]);
		}, 1000 + 200*count);
		list_elem.append(option_elem);

		self.counter++;

		return status;
	}

	showTitleScreen(title_type) {
		$("#select_screen").removeClass("show");
		$("#blackback").removeClass("show");
		$("#overlay_blood").removeClass("show");
		$("#overlay_crash").removeClass("show");
		$("#screen_image").removeClass("show bottom_to_top bottom transparent");
		$("#caption").removeClass("show");
		$("#narration").removeClass("show");
		$("#chapter_title").removeClass("show");
		$("#chat_window .mobile_frame").removeAttr("type");
		$("#chat_window").removeAttr("type");
		$("#main_menu_container").removeClass("show notice");

		var title_screen = $("#title_screen");
		$("#button_start").removeClass("disabled selected");
		$("#button_story_index").removeClass("disabled selected");
		$("#button_share_app").removeClass("disabled selected");
		$("#button_store").removeClass("disabled selected");
		$("#button_restore").removeClass("disabled selected");

		// complete??
		if (this.story_index.isEndAllChapters()) {
			var flag_name = "_section_status_complete_01";
			if (this.flags[flag_name] != "end") {
				this.flags[flag_name] = "begin";
				this.saveData();
			}
		}

		this.removeFlags();

		// banner
		this.banner_ad_component.hide();
		$(".mobile_pseudo_banner_ad").removeClass("show");
		$(".mobile_chat_timeline").removeClass("ad_show");

		title_screen.attr("title_type", title_type);
		title_screen.addClass("show");
	}

	hideTitleScreen() {
		var title_screen = $("#title_screen");
		setTimeout(() => {
			title_screen.removeAttr("title_type");
		}, 2000);
		title_screen.removeClass("show");
	}

	handleCommandTitleScreen(script_part) {
		switch (script_part.action) {
			case "show":
			this.showTitleScreen(script_part.title_type);
			break;

			case "hide":
			this.hideTitleScreen();
			this.commandDone(5000);
			break;
		}
	}

	handleCommandFlag(script_part) {
		this.setFlag(script_part.expr);
		this.commandDone(0);
		return false;
	}

	doVibrate(pattern) {
		if (navigator.vibrate) {
			navigator.vibrate(pattern);
		} else {
			console.log("do not support vibrate");
		}
	}

	handleCommandBGM(script_part) {
		audio_manager.fadeBGM(
			script_part.filename,
			script_part.volume,
			script_part.fade_duration,
			(script_part.loop === "true"),
			script_part.loop_start,
			script_part.loop_end
		);

		this.commandDone(0);
		return false;
	}

	handleCommandBGMLong(script_part) {
		audio_manager.fadeBGMLong(
			script_part.filename,
			script_part.volume,
			script_part.fade_duration,
			(script_part.loop === "true")
		);

		this.commandDone(0);
		return false;
	}

	handleCommandSE(script_part) {
		audio_manager.playSE(
			script_part.filename,
			script_part.volume
		);

		this.commandDone(0);
		return false;
	}

	playSE(filename, volume) {
		audio_manager.playSE(
			filename,
			volume
		);
	}

	pauseAllAudios() {
		audio_manager.suspend();
	}
	playPausedAudios() {
		audio_manager.resume();
	}

	showRewardAd(callback_reward, callback_cancel, callback_fail) {
		if (!this.interstitial_ad_component || !this.interstitial_ad_component.is_available) {
			return false;
		}

		var self = this;
		var reward_ok = true;
		this.showLoading();
		tgsdk.couldShowAd(
			"xrLBMFLuiHeec9rWZLv",
			function(){
				window.tgsdk.showAd("xrLBMFLuiHeec9rWZLv");
			},
			function() {
				console.log("[cordova] not ready");
			}
		);
		self.hideLoading();
		self.interstitial_ad_component.prepareAds();
		callback_reward();
		return false
	}

	handleCommandInterstitialAd(script_part) {
		if (!this.interstitial_ad_component || !this.interstitial_ad_component.is_available) {
			this.commandDone(0);
			return false;
		}

		var self = this;
		this.showLoading();
		tgsdk.couldShowAd(
			"xrLBMFLuiHeec9rWZLv",
			function(){
				window.tgsdk.showAd("xrLBMFLuiHeec9rWZLv");
			},
			function() {
				console.log("[cordova] not ready");
			}
		);
		self.hideLoading();
		self.commandDone(0);
		self.interstitial_ad_component.prepareAds();
		return false
	}

	handleCommandBannerAd(script_part) {
		var is_offline = true;
		if (this.banner_ad_component && this.banner_ad_component.is_available) {
			is_offline = false;
		}

		var pseudo_ad = $(".mobile_pseudo_banner_ad");

		var show_pseudo_ad = function(image) {
			if (!image) {
				pseudo_ad.css("background-image", "none");
			} else {
				pseudo_ad.css("background-image", "url("+image+")");
			}
			$(".mobile_chat_timeline").addClass("ad_show");
			pseudo_ad.addClass("show");
		};
		var hide_pseudo_ad = function() {
			pseudo_ad.css("background-image", "none");
			$(".mobile_chat_timeline").removeClass("ad_show");
			pseudo_ad.removeClass("show");
		};

		var self = this;
		var success = false;
		var do_next = (script_part._do_next) ? script_part._do_next : 0;
		switch (script_part.action) {
			case "load":
			if (is_offline) {
				self.commandDone(do_next);
				break;
			}
			var set_load_callback_succeed = self.banner_ad_component.setLoadSuccessCallback(self, function() {
				self.hideLoading();
				self.commandDone(do_next);
			});
			self.banner_ad_component.setLoadFailCallback(self, function() {
				self.hideLoading();
				self.commandDone(do_next);
			});
			if (!set_load_callback_succeed) {
				self.commandDone(do_next);
			} else {
				self.showLoading();
				self.banner_ad_component.prepareAds();
			}
			break;

			case "show":
			if (script_part.image) {
				show_pseudo_ad(script_part.image);
				self.commandDone(do_next);
			} else {
				if (is_offline) {
					show_pseudo_ad(PSEUDO_BANNER_AD);
					self.commandDone(do_next);
					break;
				}
				success = self.banner_ad_component.show(() => {
					self.commandDone(do_next);
				}, () => {
					show_pseudo_ad(PSEUDO_BANNER_AD);
					self.commandDone(do_next);
				});
				if (!success) {
					show_pseudo_ad(PSEUDO_BANNER_AD);
					self.commandDone(do_next);
				}
			}
			break;

			case "hide":
			if (is_offline) {
				hide_pseudo_ad();
				self.commandDone(do_next);
				break;
			}
			hide_pseudo_ad();
			success = self.banner_ad_component.hide(() => {
				self.commandDone(do_next);
			}, () => {
				self.commandDone(do_next);
			});
			if (!success) {
				self.commandDone(do_next);
			}
			break;
		}

		return false;
	}

	handleCommandGAView(script_part) {
		this.ga_component.trackView(script_part.screen);
		this.commandDone(0);
		return false;
	}

	handleCommandGAEvent(script_part) {
		this.ga_component.trackEvent(
			script_part.category,
			script_part.action,
			script_part.label,
			script_part.value
		);
		this.commandDone(0);
		return false;
	}

	showLoading() {
		$("#screen_loading").addClass("show");
	}

	hideLoading() {
		$("#screen_loading").removeClass("show");
	}

	showDialog(caption, options) {
		var select_screen = $("#select_screen");
		var select_screen_content = select_screen.find(".select_screen_content");
		select_screen_content.html("");
		var caption_elem = $("<div class='caption'>"+caption+"</div>");
		var list_elem = $("<ul></ul>");

		var add_option = function(option) {
			var li = $("<li class='button_default se_button_p disabled'>"+option.caption+"</i></li>");
			if (option.type) {
				li.attr("type", option.type);
				if (option.type == "sub_option") {
					li.removeClass("se_button_p");
					li.addClass("se_button_n");
				}
			}
			var self = this;
			li.on("click", function() {
				if ($(this).hasClass("disabled")) {
					return;
				}
				select_screen.find(".button_default").addClass("disabled");
				$(this).addClass("selected");

				wait(1000).then(() => {
					select_screen.removeClass("show");
					if (typeof(option.callback) == "function") {
						option.callback();
					}
				});
			});
			var count = list_elem.find(".button_default").length;
			setTimeout(() => {
				if (list_elem.find(".button_default.selected").length > 0) return;
				li.removeClass("disabled");
				audio_manager.playSE(FIXED_SE["menu_button_show"]);
			}, 1000 + 200*count);
			list_elem.append(li);
		};

		for (var i = 0; i < options.length; i++) {
			add_option(options[i]);
		}

		select_screen_content.append(caption_elem);
		select_screen_content.append(list_elem);

		audio_manager.playSE(FIXED_SE["selectscreen"]);
		$("#select_screen").addClass("show");
	}

	handleCommandGameover(script_part) {
		var select_screen = $("#select_screen");
		var select_screen_content = select_screen.find(".select_screen_content");
		select_screen_content.html("");
		var caption_elem = $("<div class='caption'>观看广告<br>可以从错误选项前<br>重新来过</div>");
		var list_elem = $("<ul></ul>");

		var option_elem_continue = $("<li class='button_default se_button_p disabled'>观看</i></li>");
		var self = this;
		option_elem_continue.on("click", function() {
			if ($(this).hasClass("disabled")) {
				return;
			}
			$(".button_default").addClass("disabled");
			$(this).addClass("selected");

			setTimeout(function() {
				$("#select_screen").removeClass("show");
				self.showLoading();
				var reward_ok = true;
				tgsdk.couldShowAd(
					"xrLBMFLuiHeec9rWZLv",
					function(){
						window.tgsdk.showAd("xrLBMFLuiHeec9rWZLv");
					},
					function() {
						console.log("[cordova] not ready");
					}
				);
				self.hideLoading();
				self.commandDone();
				self.initTimeline();
				self.gotoLabel(script_part.label_continue).then(() => {
					self.forwardTimeline();
				});
				self.reward_ad_component.prepareAds();
			}, 1000);
		});
		wait(1000).then(() => {
			option_elem_continue.removeClass("disabled");
			audio_manager.playSE(FIXED_SE["menu_button_show"]);
		});

		list_elem.append(option_elem_continue);

		var option_elem_end = $("<li class='button_default se_button_n disabled' type='sub_option'>返回标题界面</li>");
		option_elem_end.on("click", function() {
			if ($(this).hasClass("disabled")) {
				return;
			}
			$(".button_default").addClass("disabled");
			$(this).addClass("selected");

			setTimeout(function() {
				$("#select_screen").removeClass("show");
				self.commandDone();
				self.initTimeline();
				self.gotoLabel(script_part.label_end).then(() => {
					self.forwardTimeline();
				});
			}, 1000);
		});
		wait(1000 + 200).then(() => {
			option_elem_end.removeClass("disabled");
			audio_manager.playSE(FIXED_SE["menu_button_show"]);
		});

		list_elem.append(option_elem_end);

		select_screen_content.append(caption_elem);
		select_screen_content.append(list_elem);

		audio_manager.playSE(FIXED_SE["selectscreen"]);
		$("#select_screen").addClass("show");
	}

	handleCommandScene(script_part) {
		if (this.scene && (this.scene.name == script_part.name)) {
			this.commandDone(0);
			return false;
		}

		$(".chat_stage_person").removeClass("show focused");
		$(".chat_stage_person").removeAttr("person_id");
		$(".chat_stage_person").removeAttr("image_id");

		$("#overlay_atom").removeAttr("type");
		$("#overlay_atom").removeClass("show");

		for (var i in this.persons) {
			this.persons[i].chat_status = "logout";
		}

		this.scene = this.scenes[script_part.name];
		if (this.scene) {
			$("#chat_window").attr("scene_type", this.scene.type);
			$("#chat_window").attr("scene_name", this.scene.name);
			switch (this.scene.type) {
				case "f2f":
				this.chat.html("");
				$("#chat_window .f2f_frame").css("background-image", "url("+this.scene.background+")");
				if (this.scene.atom_type) {
					$("#overlay_atom").attr("type", this.scene.atom_type);
					$("#overlay_atom").addClass("show");
				}
				if (!this.isTalkingF2P()) {
					this.changeMobileFramePos(undefined, "hidden");
				}
				break;

				case "chat":
				this.mobile_chat.html("");
				this.mobile_chat.css("background-image", "url("+this.scene.background+")");
				this.changeMobileFramePos(undefined, "fullscreen");
				break;

				default:
			}
		} else {
			$("#chat_window").removeAttr("scene_type");
			$("#chat_window").removeAttr("scene_name");
			this.chat.css("background-image", "");
			this.mobile_chat.css("background-image", "");
			$("#overlay_atom").removeAttr("type");
			$("#overlay_atom").removeClass("show");
			console.error("unknown scene: ", script_part.name);
		}

		var duration = (this.scene.type == "chat") ? 1200 : 1000;
		if (!isNaN(script_part._do_next)) {
			duration = script_part._do_next;
		}
		this.commandDone(duration);
		return false;
	}

	clearTimeline() {
		var chat_stage_person = $(".chat_stage_person");
		chat_stage_person.removeClass("show focused");
		chat_stage_person.removeAttr("person_id");
		chat_stage_person.removeAttr("image_id");

		for (var i in this.persons) {
			this.persons[i].chat_status = "logout";
		}

		this.chat.html("");
		this.mobile_chat.html("");
	}

	handleCommandClearTimeline(script_part) {
		var duration = 0;
		if (!isNaN(script_part._do_next)) {
			duration = script_part._do_next;
		}
		this.clearTimeline();
		this.commandDone(duration);
		return false;
	}

	handleCommandDomClass(script_part) {
		var element = $(script_part.element);
		if (element.length <= 0) {
			this.commandDone(0);
			return false;
		}

		switch (script_part.action) {
			case "add":
			element.addClass(script_part.class_name);
			break;

			case "remove":
			element.removeClass(script_part.class_name);
			break;

			default:
		}

		if (script_part._do_next) {
			this.commandDone(script_part._do_next);
			return false;
		} else {
			this.commandDone(0);
			return false;
		}
	}

	handleCommandCaption(script_part) {
		var caption = $("#caption");
		var caption_text = caption.find(".caption_text");
		var duration = (script_part._do_next && !isNaN(script_part._do_next)) ? script_part._do_next : undefined;

		switch(script_part.action) {
			case "show":
			if (!script_part.text) return true;

			var showText = () => {
				caption.removeClass("left right top bottom");
				if (script_part.effect) {
					caption.addClass(script_part.effect);
				}
				caption_text.html(script_part.text);
				caption.addClass("show");
				if (duration) {
					this.commandDone(duration);
				} else {
					setTimeout(() => {
						this.commandDone();
					}, 500);
				}
			};

			if (caption.hasClass("show")) {
				caption.removeClass("show");
				setTimeout(function() {
					showText();
				}, 500);
			} else {
				showText();
			}
			break;

			case "hide":
			caption.removeClass("show");
			setTimeout(() => {
				caption_text.html("");
			}, 700);
			this.commandDone(700);
			break;
		}
	}

	handleCommandShare(script_part) {
		this.shareThisApp(
			SHARE_OPTION_NORMAL,
			this.commandDone,
			this.commandDone
		);
	}

	handleCommandChatLogin(script_part) {
		var person = this.persons[script_part.person_id];
		if (!person) {
			this.commandDone(0);
			return false;
		}

		person.chat_status = "login";

		var do_next = script_part._do_next;
		if (!do_next) {
			do_next = 0;
		}
		this.commandDone(do_next);
		return false;
	}

	handleCommandChatLogout(script_part) {
		var person = this.persons[script_part.person_id];
		if (!person) {
			this.commandDone(0);
			return false;
		}

		person.chat_status = "logout";

		var target = $(".chat_stage_person[person_id="+person.id+"]");
		target.removeClass("show focused");
		target.removeAttr("person_id");
		target.removeAttr("image_id");

		var do_next = script_part._do_next;
		if (!do_next) {
			do_next = 0;
		}
		this.commandDone(do_next);
		return false;
	}

	handleCommandImage(script_part) {
		var screen_image = $("#screen_image");
		var duration = 1000;
		if (script_part.duration && !isNaN(script_part.duration) && (script_part.duration >= 0)) {
			duration = script_part.duration;
		}
		if (script_part.filename && (script_part.filename != "")) {
			if (this.timers["_command_image"]) {
				clearTimeout(this.timers["_command_image"]);
				delete this.timers["_command_image"];
			}
			screen_image.css("transition-duration", duration + "ms");
			screen_image.css("background-image", "url("+script_part.filename+")");
			screen_image.addClass("show");
			setTimeout(() => {
				this.commandDone(script_part._do_next);
			}, duration);
			return false;
		} else {
			screen_image.css("transition-duration", duration + "ms");
			screen_image.removeClass("show");
			this.commandDone(script_part._do_next || duration);
			this.timers["_command_image"] = setTimeout(() => {
				screen_image.css("background-image", "url("+TRANSPARENT_IMAGE+")");
			}, duration);
			return false;
		}
	}

	handleCommandImageMobile(script_part) {
		var mobile_frame = $("#chat_window .mobile_frame");
		var mobile_image_view = mobile_frame.find(".mobile_image_view");
		if (script_part.filename && (script_part.filename != "")) {
			mobile_image_view.css("background-image", "url("+script_part.filename+")");
			mobile_frame.attr("type", "image");
			this.changeMobileFramePos(undefined, "fullscreen");
			setTimeout(() => {
				this.commandDone(script_part._do_next);
			}, 2000);
			return false;
		} else {
			mobile_frame.removeAttr("type");
			this.changeMobileFramePos(undefined, "hidden");
			setTimeout(() => {
				mobile_image_view.css("background-image", "");
			}, script_part._do_next || 1000);
			this.commandDone(script_part._do_next || 1000);

			return false;
		}
	}

	handleCommandCallScreen(script_part) {
		var mobile_call_view = $(".mobile_call_view");
		var call_icon = mobile_call_view.find(".call_icon");
		var call_name = mobile_call_view.find(".call_name");
		var call_status = mobile_call_view.find(".call_status");
		var call_button_connect = mobile_call_view.find(".call_button_connect");
		var call_button_disconnect = mobile_call_view.find(".call_button_disconnect");
		var mobile_frame = $(".mobile_frame");

		var person = this.getPerson(script_part.person_id);
		if (person) {
			call_icon.css("background-image", "url("+person.icon+")");
			call_name.html(person.name);
		} else {
			console.error("unknown person", script_part.person_id);
		}

		var self = this;
		var timer = undefined;
		var finCallScreen = function(expr, keep, next) {
			if (timer) {
				clearTimeout(timer);
				timer = undefined;
			}
			self.doVibrate([0]);
			if (expr) {
				self.setFlag(expr);
			}
			if (!keep) {
				self.changeMobileFramePos(undefined, "hidden");
				mobile_frame.removeAttr("type");
				mobile_call_view.removeClass("show");
			}
			self.commandDone(next);
		};

		call_button_connect.on("click", function() {
			call_button_connect.off("click");
			self.playSE(FIXED_SE["call_begin"]);
			finCallScreen(script_part.expr_success, true, 0);
		});
		call_button_disconnect.on("click", function() {
			call_button_disconnect.off("click");
			self.playSE(FIXED_SE["call_end"]);
			finCallScreen(script_part.expr_failed, undefined, 0);
		});

		if (!isNaN(script_part.duration) && script_part.duration >= 0) {
			timer = setTimeout(function() {
				switch (script_part.type) {
					case "from":
					case "from_force":
					case "to":
					finCallScreen(script_part.expr_failed, undefined, 0);
					break;

					case "connecting":
					finCallScreen(script_part.expr_success, undefined, 0);
					break;

					case "talking":
					self.playSE(FIXED_SE["call_disconnect"]);
					finCallScreen(script_part.expr_success, undefined, 0);
					break;

					default:
				}
			}, script_part.duration);
		} else {
			// [special] duration is filename
			var filename = script_part.duration;
			if (script_part.type == "talking") {
				wait(500).then(() => {
					audio_manager.playSE(filename).then(() => {
						self.playSE(FIXED_SE["call_disconnect"]);
						finCallScreen(script_part.expr_success, undefined, 0);
					});
				});
			}
		}

		switch (script_part.type) {
			case "from":
			case "from_force":
			var vibrate_pattern = [];
			for (var i = 0; i<1000; i++) {
				if (i%2) {
					vibrate_pattern.push(500);
				} else  {
					vibrate_pattern.push(1000);
				}
			}
			this.doVibrate(vibrate_pattern);
			mobile_frame.attr("type", "call");
			this.changeMobileFramePos(undefined, "fullscreen");
			break;

			case "to":
			mobile_frame.attr("type", "call");
			this.changeMobileFramePos(undefined, "fullscreen");
			break;

			case "connecting":
			mobile_frame.attr("type", "call");
			this.changeMobileFramePos(undefined, "fullscreen");
			break;

			case "talking":
			mobile_frame.attr("type", "call");
			this.changeMobileFramePos(undefined, "fullscreen");
			break;

			case "talking_f2p":
			var duration = (mobile_frame.attr("type") == "call_f2p") ? 0 : 1000;
			mobile_frame.attr("type", "call_f2p");
			this.commandDone(duration);
			this.changeMobileFramePos(undefined, "left");
			break;

			case "close":
			finCallScreen(undefined, undefined, 1000);
			break;

			default:
		}
		mobile_call_view.attr("type", script_part.type);
		$("#chat_window").attr("scene_type", "f2f");

		return false;
	}

	changeMobileFramePos(pos_from, pos_to) {
		var mobile_frame = $(".mobile_frame");
		var pfrom = pos_from;
		var pto = pos_to;

		if (pos_from) {
			pfrom = pos_from;
		} else if (mobile_frame.attr("frame_pos_to")) {
			pfrom = mobile_frame.attr("frame_pos_to");
		} else {
			pfrom = "hidden";
		}

		mobile_frame.attr("frame_pos_from", pfrom);
		mobile_frame.attr("frame_pos_to", pto);
	}

	isTalkingF2P() {
		return ($(".mobile_frame").attr("type") == "call_f2p");
	}

	handleCommandMainMenu(script_part) {
		switch(script_part.action) {
			case "show":
			$("#main_menu_container").addClass("show");
			break;

			case "hide":
			$("#main_menu_container").removeClass("show");
			break;
		}
		this.commandDone(0);
		return false;
	}

	handleCommandFlash(script_part) {
		var overlay_flash = $("#overlay_flash");
		overlay_flash.addClass("show");
		wait(1200).then(() => {
			overlay_flash.removeClass("show");
		});
		this.commandDone(0);
		return false;
	}

	handleCommandChatLogUI(script_part) {
		if (this.scene.type == "f2f") {
			this.commandDone(0);
			return false;
		}

		var target_chat = this.mobile_chat;
		var button_chat_log = $("<div class='timeline_object se_click button_chat_log disabled' type='"+script_part.type+"'></div>");
		var splitter = $("<div class='timeline_splitter'></div>");

		switch (script_part.type) {
			case "close":
			button_chat_log.html("<i class='fa fa-times'></i> 关闭");
			button_chat_log.on("click", () => {
				this.commandDone(0);
			});
			wait(1000).then(() => {
				button_chat_log.removeClass("disabled");
			});
			break;

			case "next":
			button_chat_log.html("<i class='fa fa-arrow-down'></i> 继续");
			button_chat_log.on("click", () => {
				this.commandDone(0);
				button_chat_log.remove();
				$(".timeline_splitter").remove();
				target_chat.append(splitter);
			});
			wait(1000).then(() => {
				button_chat_log.removeClass("disabled");
			});
			break;
		}

		target_chat.append(button_chat_log);

		scrollToElement(target_chat, button_chat_log);
		return false;
	}

	handleCommandOpenLink(script_part) {
		var url = OTHERAPP_URL[script_part.id] ? OTHERAPP_URL[script_part.id][OS_TYPE] : undefined;
		if (url) {
			timeline.ga_component.trackEvent("button", "click", "open_otherapp_"+script_part.id);
			window.open(url, "_system", "location=no");
		}
		this.commandDone(0);
		return false;
	}

	handleCommandRateAPP(script_part) {
		AppRate.preferences.storeAppURL = {
			ios: '1401196093',
			android: 'market://details?id=com.pujiadev.chatnovel4',
			windows: 'ms-windows-store://pdp/?ProductId=<the apps Store ID>',
		};
		AppRate.preferences.useLanguage = 'zh-Hans';
		AppRate.promptForRating();
		this.commandDone(0);
		return false;
	}

	handleCommandStore(script_part) {
		var item_id = script_part.id;
		if (!item_id) {
			this.commandDone(0);
			return false;
		}

		var self = this;
		var flag_name = "_item_" + item_id;

		switch (script_part.action) {
			case "buy":
			store_manager.setCallbackApproved(item_id, function(product) {
				store_manager.unsetCallbacks(item_id);
				self.flags[flag_name] = 1;
				self.saveData();
				self.hideLoading();
				self.commandDone(0);
			});
			store_manager.setCallbackCancelled(item_id, function(product) {
				store_manager.unsetCallbacks(item_id);
				self.hideLoading();
				self.commandDone(0);
			});
			store_manager.setCallbackError(item_id, function(product) {
				store_manager.unsetCallbacks(item_id);
				self.hideLoading();
				self.commandDone(0);
			});

			self.showLoading();
			if (!store_manager.purchaseProduct(item_id)) {
				self.hideLoading();
				self.commandDone(0);
			};
			break;

			case "ask":
			var is_owned_product = store_manager.isOwnedProduct(item_id);
			if (is_owned_product === undefined) {
				// do nothing
			} else if (is_owned_product) {
				self.flags[flag_name] = 1;
				self.saveData();
			} else {
				self.flags[flag_name] = 0;
				self.saveData();
			}
			self.commandDone(0);
			break;

			default:
			self.commandDone(0);
		}

		return false;
	}

	handleCommandChapterTitle(script_part) {
		var chapter_title = $("#chapter_title");
		var text1_elem = chapter_title.find(".chapter_title_text1");
		var text2_elem = chapter_title.find(".chapter_title_text2");

		text1_elem.html();
		text2_elem.html();

		switch(script_part.action) {
			case "show":
			text1_elem.html(script_part.text1);
			text2_elem.html(script_part.text2);
			chapter_title.addClass("show");
			wait(4000).then(() => {
				this.commandDone(script_part._do_next);
			});
			break;

			case "hide":
			chapter_title.removeClass("show");
			this.commandDone(500);
			break;

			default:
			this.commandDone(0);
		}
		return false;
	}

	getPersonsChatLogin() {
		var result = [];
		for (var i in this.persons) {
			if (this.persons[i].chat_status == "login") {
				result.push(this.persons[i]);
			}
		}
		return result;
	}

	readPersonChatAll(target_person) {
		var login_persons = this.getPersonsChatLogin();
		var delay = 0;
		for (var i in login_persons) {
			login_persons[i].readPersonChat(target_person, delay+=100);
		}
	}

	getScriptPart() {
		return (this.timeline_script.length > this.counter) ? this.timeline_script[this.counter] : undefined;
	}

	forwardTimeline() {
		if (!this.is_ready) return;
		if (this.commandBlocking()) {
			this.doBlockingAction();
			return;
		}
		if (this.isEndOfScript()) {
			this.initTimeline();
			return;
		}
		if (this.showNewContentAndAbortCommand()) return;

		var script_part = this.getScriptPart();

		if (script_part.command === undefined) {
			this.counter++;
			return;
		}

		this.commandBlock();
		var handleCommands = {
			"init": this.handleCommandInit,
			"nothing": this.handleCommandNothing,
			"say": this.handleCommandSay,
			"say_effect": this.handleCommandSayEffect,
			"emotion": this.handleCommandEmotion,
			"attach": this.handleCommandAttach,
			"stamp": this.handleCommandStamp,
			"split": this.handleCommandSplit,
			"narration": this.handleCommandNarration,
			"colorscreen": this.handleCommandColorScreen,
			"label": this.handleCommandLabel,
			"section": this.handleCommandSection,
			"goto": this.handleCommandGoto,
			"select": this.handleCommandSelect,
			"titlescreen": this.handleCommandTitleScreen,
			"flag": this.handleCommandFlag,
			"bgm": this.handleCommandBGM,
			"bgm_long": this.handleCommandBGMLong,
			"se": this.handleCommandSE,
			"ad_interstitial": this.handleCommandInterstitialAd,
			"ad_banner": this.handleCommandBannerAd,
			"ga_view": this.handleCommandGAView,
			"ga_event": this.handleCommandGAEvent,
			"gameover": this.handleCommandGameover,
			"scene": this.handleCommandScene,
			"clear_timeline": this.handleCommandClearTimeline,
			"dom_class": this.handleCommandDomClass,
			"caption": this.handleCommandCaption,
			"share": this.handleCommandShare,
			"chat_login": this.handleCommandChatLogin,
			"chat_logout": this.handleCommandChatLogout,
			"image": this.handleCommandImage,
			"image_mobile": this.handleCommandImageMobile,
			"callscreen": this.handleCommandCallScreen,
			"main_menu": this.handleCommandMainMenu,
			"flash": this.handleCommandFlash,
			"chat_log_ui": this.handleCommandChatLogUI,
			"open_link": this.handleCommandOpenLink,
			"store": this.handleCommandStore,
			"chapter_title": this.handleCommandChapterTitle,
			"rate_app": this.handleCommandRateAPP,
		};

		if (typeof(handleCommands[script_part.command]) == "function") {
			handleCommands[script_part.command].call(this, script_part);
		}

		this.counter++;
	}

	isEndOfScript() {
		if (this.counter >= this.timeline_script.length) {
			return true;
		}
		return false;
	}

	clearAllTimers() {
		for (var key in this.timers) {
			if (this.timers[key]) {
				clearTimeout(this.timers[key]);
				delete this.timers[key];
			}
		}
	}

	removeFlags() {
		for (var key in this.flags) {
			// do not remove flags which begins "_"
			if (key[0] != "_") {
				delete this.flags[key];
			}
		}
	}
	removeAllFlags() {
		for (var key in this.flags) {
			delete this.flags[key];
		}
	}
	endAllChapters() {
		if (!this.story_index) return;
		this.story_index.endAllChapters();
		this.flags["_ending_normal"] = 1;
		this.flags["_ending_true"] = 1;
	}

	initTimeline() {
		this.chat.html("");
		this.mobile_chat.html("");
		$("#chat_window").removeAttr("scene");
		this.waiting = false;
		this.timer_start = {};
		this.last_label = "";
		this.say_effects = "";

		this.removeFlags();

		this.clearAllTimers();
		this.timers = {};
	}

	showOldContent(target) {
		var obj = undefined;
		var timer = setInterval(() => {
			if (this.getScrollPos(target) > 0) {
				clearInterval(timer);
				return;
			}
			obj = target.find(".timeline_object.hidden_old:eq(-1)");
			if (obj.length < 1) return;
			obj.removeClass("hidden_old");
			this.hideNewContent(target);
		}, 200);
	}
	hideOldContent(target) {
		var height = target[0].clientHeight;

		var obj = undefined;
		while (target[0].scrollHeight > height*3) {
			obj = target.find(".timeline_object:not(.hidden_old)");
			if (obj.length < 1) break;

			obj.filter(":eq(0)").addClass("hidden_old");
		}
	}

	showNewContent(target) {
		var obj = undefined;

		for (var i = 0; i < 5; i++) {
			obj = target.find(".timeline_object.hidden_new:eq(0)");
			if (obj.length < 1) break;
			obj.removeClass("hidden_new");
		}

		this.hideOldContent(target);
	}
	hideNewContent(target) {
		var height = target[0].clientHeight;

		var obj = undefined;
		while (target[0].scrollHeight > height*3) {
			obj = target.find(".timeline_object:not(.hidden_new)");
			if (obj.length < 1) break;

			obj.filter(":eq(-1)").addClass("hidden_new");
		}
	}

	showNewContentAndAbortCommand() {
		if ($(".timeline_object.hidden_new").length) {
			var target = (this.mobile_chat.hasClass("show")) ? this.mobile_chat : this.chat;
			scrollToElement(target, $(".timeline_object:visible:eq(-1)"));
			return true;
		}
		return false;
	}

	getScrollPos(target) {
		var height = target[0].scrollHeight - target[0].clientHeight;
		var top = target[0].scrollTop;
		if (height <= 0) return undefined;

		return top / height;
	}

	jumpTimeline(label_name, flags) {
		this.gotoLabel(label_name).then(() => {
			this.initTimeline();

			if (typeof(flags) === "object") {
				this.flags = flags;
			}
		});
	}

	dumpTimelinePoint() {
		console.log(this.getScriptPart());
		console.log(this.flags);
		console.log(this.last_label);
	}

	saveData() {
		var flag_temp = Object.assign({}, this.flags);
		this.removeFlags();
		localStorage.setItem("last_label", this.last_label);
		localStorage.setItem("last_flags", JSON.stringify(this.flags));
		this.flags = flag_temp;
		this.showInfoTip("auto save");
	}

	loadData() {
		var last_label = localStorage.getItem("last_label");

		this.gotoLabel(last_label).then(() => {
			var last_flags = localStorage.getItem("last_flags");
			var flags;
			try {
				flags = JSON.parse(last_flags);
			} catch (e) {
			}

			if (flags) {
				this.flags = flags;
			}
		}).catch(() => {
			this.counter = 0;
		});
	}

	shareThisApp(share_option, callback_success, callback_fail) {
		if (!window.plugins || !window.plugins.socialsharing) {
			if (typeof(callback_fail) == "function") callback_fail();
			return;
		}
		window.plugins.socialsharing.shareWithOptions(share_option, (result) => {
			if (typeof(callback_success) == "function") callback_success();
			this.ga_component.trackEvent("button", "click", "share_success");
		}, (msg) => {
			if (typeof(callback_fail) == "function") callback_fail();
			this.ga_component.trackEvent("button", "click", "share_failed");
		});
	}
}

var audio_manager = new AudioManager();
var image_manager = new ImageManager();
var store_manager = new StoreManager();
var timeline = undefined;

function jumpTimeline(label_name, flags) {
	timeline.jumpTimeline(label_name, flags);
}
function dumpTimelinePoint() {
	timeline.dumpTimelinePoint();
}

document.addEventListener("deviceready", function() {
	if (!window.localStorage || !window.AudioContext) {
		alert("申し訳ありません。お使いの端末は本アプリに対応しておりません。");
		return;
	}

	audio_manager.init();
	store_manager.init(window.store);

	if (window.plugins && window.plugins.socialsharing) {
		window.plugins.insomnia.keepAwake();
	}

	// for iOS bug
	if (OS_TYPE == "ios") {
		MobclickAgent.init('5b42cd9db27b0a5d7a000031', 'appstore');
		$(".mobile_frame").addClass("for_ios_bug");
		wait(200).then(() => {
			$(".mobile_frame").removeClass("for_ios_bug");
		});
	}

	if (OS_TYPE == "android") {
	    MobclickAgent.init('5b42cd9db27b0a5d7a000031', 'pujia8');
    }

	timeline = new Timeline();

	interstitial_ad_component = timeline.interstitial_ad_component
	reward_ad_component = timeline.reward_ad_component

	// AdMob
	//timeline.setAdComponent(new AdComponent(AD_COMPONENT_INFO, admob));
	timeline.setRewardAdComponent(new RewardAdComponent(
		AD_COMPONENT_INFO,
		(typeof(admob) === "undefined") ? undefined : admob
	));
	timeline.setBannerAdComponent(new BannerAdComponent(
		AD_COMPONENT_INFO,
		(typeof(admob) === "undefined") ? undefined : admob
	));
	if (timeline.banner_ad_component) {
		timeline.banner_ad_component.prepareAds();
		timeline.banner_ad_component.hide();
	}

	// Google Analytics (not used: see config.xml)
	timeline.setGAComponent(new GoogleAnalyticsComponent(GA_ID));

	var dev1_sequence_timer = undefined;
	var dev2_sequence_timer = undefined;
	var dev_touchend = false;
	$("#splash_screen").on(EVENTS["touchstart"], function() {
		if (dev_touchend) return;

		dev1_sequence_timer = setTimeout(function() {
			if (dev_touchend) return;
			timeline.playSE(FIXED_SE["dev1"]);
			timeline.initTimeline();
			timeline.removeAllFlags();
			timeline.last_label = undefined;
			timeline.saveData();
			timeline.loadData();
		}, 10000);
		dev2_sequence_timer = setTimeout(function() {
			if (dev_touchend) return;
			timeline.playSE(FIXED_SE["dev2"]);
			timeline.initTimeline();
			timeline.endAllChapters();
			timeline.last_label = undefined;
			timeline.saveData();
			timeline.loadData();
		}, 15000);
	});
	$("#splash_screen").on(EVENTS["touchend"], function() {
		dev_touchend = true;
		$(this).removeClass("show");
		if (dev1_sequence_timer) {
			clearTimeout(dev1_sequence_timer);
			dev1_sequence_timer = undefined;
		}
		if (dev2_sequence_timer) {
			clearTimeout(dev2_sequence_timer);
			dev2_sequence_timer = undefined;
		}
		timeline.banner_ad_component.hide();
		wait(3000).then(() => {
			// Game Analytics
			//timeline.setGameAnalyticsManager(new GameAnalyticsManager(GAME_ANALYTICS_INFO));

			if ($("#warn_screen1").hasClass("show")) {
				$("#warn_screen1").removeClass("show");
				timeline.forwardTimeline();
			}
		});
	});

	$(document).on("click", ".se_button_go", function() {
		timeline.playSE(FIXED_SE["button_go"], 1);
	});
	$(document).on("click", ".se_button_p", function() {
		timeline.playSE(FIXED_SE["button_p"], 0.2);
	});
	$(document).on("click", ".se_button_n", function() {
		timeline.playSE(FIXED_SE["button_n"], 0.2);
	});
	$(document).on("click", ".se_button", function() {
		timeline.playSE(FIXED_SE["button"], 0.2);
	});
	$(document).on("click", ".se_click", function() {
		timeline.playSE(FIXED_SE["click"], 1);
	});

	var button_start = $("#button_start");
	var button_story_index = $("#button_story_index");
	var button_share_app = $("#button_share_app");
	var button_store = $("#button_store");
	var button_restore = $("#button_restore");
	if (!STORE_URL[OS_TYPE]) {
		button_store.addClass("disabled");
	}

	button_start.on("click", function() {
		if ($(this).hasClass("disabled")) return;
		button_story_index.addClass("disabled");
		button_share_app.addClass("disabled");
		button_store.addClass("disabled");
		button_restore.addClass("disabled");
		$(this).addClass("disabled selected");
		timeline.commandDone(500);
	});
	button_story_index.on("click", function() {
		if ($(this).hasClass("disabled")) return;
		wait(300).then(() => {
			var screen_story_index = $("#screen_story_index");
			screen_story_index.html("");
			screen_story_index.append(timeline.story_index.getStoryIndexElement());
			screen_story_index.addClass("show");
		});
	});
	button_share_app.on("click", function() {
		if ($(this).hasClass("disabled")) return;
		if (!$("#title_screen").hasClass("show")) return;
		timeline.ga_component.trackEvent("button", "click", "share_app_2");
		timeline.shareThisApp(SHARE_OPTION_NORMAL);
	});
	button_store.on("click", function() {
		if ($(this).hasClass("disabled")) return;
		if (!$("#title_screen").hasClass("show")) return;
		if (STORE_URL[OS_TYPE]) {
			timeline.ga_component.trackEvent("button", "click", "open_store");
			window.open(STORE_URL[OS_TYPE], "_system", "location=no");
		}
	});
	button_restore.on("click", function() {
		if ($(this).hasClass("disabled")) return;
		if (!$("#title_screen").hasClass("show")) return;
		timeline.showDialog("恢复购买<hr>如果你之前购买过本商品<br>可以在这里进行恢复", [{
			caption: "OK",
			callback: function() {
				store_manager.refresh();
				if (store_manager.activateSections(timeline)) {
					// !!! hard coding !!!
					if (timeline.flags["_section_status_intermission_01"] != "end") {
						timeline.flags["_section_status_intermission_01"] = "begin";
					}
					timeline.showDialog("恢复成功", [{
						caption: "OK",
						callback: function() {
							timeline.gotoLabel(TIMELINE_ROOT_FILENAME + ":label_begin").then(() => {
								timeline.commandDone(0);
							});
						}
					}]);
				} else {
					timeline.showDialog("恢复失败<hr>没有已购买的商品", [{caption: "OK"}]);
				}
			}
		}, {
			caption: "取消",
			type: "sub_option",
		}]);
	});

	var button_ourapp = $("#button_ourapp");
	if (!OURAPP_URL[OS_TYPE]) {
		button_ourapp.addClass("disabled");
	}

	button_ourapp.on("click", function() {
		if ($(this).hasClass("disabled")) return;
		if (!$("#title_screen").hasClass("show")) return;
		if (OURAPP_URL[OS_TYPE]) {
			timeline.ga_component.trackEvent("button", "click", "open_ourapp");
			window.open(OURAPP_URL[OS_TYPE], "_system", "location=no");
		}
	});

	$("#narration").on(EVENTS["touchend"], function() {
		if ($(this).hasClass("show") && !timeline.commandBlocking()) {
			timeline.forwardTimeline();
		}
	});
	$("#chapter_title").on(EVENTS["touchend"], function() {
		if ($(this).hasClass("show") && !timeline.commandBlocking()) {
			timeline.forwardTimeline();
		}
	});
	$("#colorscreen").on(EVENTS["touchend"], function() {
		if ($(this).hasClass("show") && !timeline.commandBlocking()) {
			timeline.forwardTimeline();
		}
	});

	var main_menu_container = $("#main_menu_container");
	$(".button_main_menu").on("click", function() {
		if (main_menu_container.hasClass("opened")) {
			main_menu_container.removeClass("opened");
			timeline.showNextIndicator();
			timeline.playSE(FIXED_SE["pulldown_close"], 1);
		} else {
			main_menu_container.addClass("opened");
			timeline.hideNextIndicator();
			timeline.playSE(FIXED_SE["pulldown_open"], 1);
		}
	});
	$(".main_menu_background").on(EVENTS["touchend"], function(evt) {
		main_menu_container.removeClass("opened");
		timeline.showNextIndicator();
		timeline.playSE(FIXED_SE["pulldown_close"], 1);
		evt.stopPropagation();
		evt.preventDefault();
	});
	$(".main_menu_list li").on("click", function() {
		$(this).addClass("selected");
		wait(500).then(() => {
			$(this).removeClass("selected");
			main_menu_container.removeClass("opened");
			timeline.showNextIndicator();
		});
	});

	$("#menu_share_app").on("click", function() {
		wait(500).then(() => {
			var callback;
			callback = function() {
				timeline.ga_component.trackEvent("button", "click", "share_app_1");
				timeline.commandDone();
			};
			timeline.shareThisApp(SHARE_OPTION_NORMAL, callback, callback);
		});
	});
	$("#menu_go_to_title").on("click", function() {
		wait(500).then(() => {
			timeline.gotoTitleScreen();
		});
	});

	$(".mobile_image_view").on(EVENTS["touchend"], function() {
		timeline.forwardTimeline();
	});

	document.addEventListener("pause", function() {
		dev_touchend = true;
		timeline.pauseAllAudios();
	}, false);
	document.addEventListener("resume", function() {
		timeline.playPausedAudios();
	}, false);
}, false);
