var PACKAGE_NAME = "com.pujiadev.chatnovel4";

var STORE_PRODUCTS = {
	"key_extra01": {
		type: "non-consumable",
	},
};

class StoreManager {
	constructor() {
		this.is_ready = false;
		this.callbacks_approved = {};
		this.callbacks_cancelled = {};
		this.callbacks_error = {};
	}

	init(store_obj) {
		try {
			//Block of code to try
			console.log("[StoreManager] init");
			cordova.plugins.pujiapay.init(function success(e){},function error(e){});
			this.is_ready = true;
		}
		catch(err) {
			//Block of code to handle errors
			this.is_ready = false;
			console.log("[StoreManager] init error");
		}
	}

	setCallbackApproved(alias, func) {
		if (typeof(func) == "function") {
			this.callbacks_approved[alias] = func;
		}
	}

	setCallbackCancelled(alias, func) {
		if (typeof(func) == "function") {
			this.callbacks_cancelled[alias] = func;
		}
	}

	setCallbackError(alias, func) {
		if (typeof(func) == "function") {
			this.callbacks_error[alias] = func;
		}
	}

	unsetCallbacks(alias) {
		if (!alias) return;
		this.callbacks_approved[alias] = undefined;
		this.callbacks_cancelled[alias] = undefined;
		this.callbacks_error[alias] = undefined;
	}

	purchaseProduct(alias) {
		console.log("[StoreManager] purchaseProduct :" + alias);
		if (!this.is_ready) return false;
		if (!alias) return false;
		var product_id = PACKAGE_NAME + "." + alias;
		var isConsumable = STORE_PRODUCTS[alias].type;
		var self = this;
		cordova.plugins.pujiapay.pay(product_id, isConsumable,
			function success(e){
	          //成功回调
			  var kFunc = self.callbacks_approved[alias];
			  if (typeof(kFunc) == "function"){
				  kFunc(alias);
			  }

	        },function error(e){
	          //失败回调
			  var eFunc = self.callbacks_error[alias];
			  if (typeof(eFunc) == "function"){
				  eFunc(alias);
			  }
	        });
		return true;
	}

	isOwnedProduct(alias){
		return undefined;
	}

}
