cordova.define("cordova-plugin-pujia8-pujiapay.PujiaPay", function(require, exports, module) {
var exec = require('cordova/exec');

/*
	先要填充key：
	gamepayConf.json
	tapdb_config.json
	在manifest中预制了placeholder，需要在gradle中定义placeholder
	placeholder参考PujiaPay.gradle

	defaultConfig {
          manifestPlaceholders = [bundleName:"com.xyz.abc", bundleHash:"86766cde"]
     }


	//当前在服务器定义的bundleName
	<meta-data android:name="gameworks_bundle_id" android:value="${bundleName}"></meta-data>
	//bundleHash是应用签名的hash，86766cde
	<meta-data android:name="gameworks_bundle_hash" android:value="${bundleHash}"></meta-data>
	//如果需要bugly的崩溃日志统计系统，人工添加元素manifest.xml
	<meta-data
            android:name="gameworks_bugly_id"
            android:value="${buglyID}" />
    usage:
    var product_id  = "xxxx.yyy.zzz";
    var isConsumable = "non-consumable";
    //初始化支付系统，越早越好
	//init payment system
    cordova.plugins.pujiapay.init(function success(e){},function error(e){});
    //购买道具
	//start purchase
    cordova.plugins.pujiapay.pay(product_id, isConsumable, function success(e){
                                                    //成功回调
                                                },function error(e){
                                                    //失败回调
                                                });
    //恢复道具
	//restore purchase
    cordova.plugins.pujiapay.restore_items(product_id, function success(e){
                                                    //成功回调
                                                },function error(e){
                                                    //失败回调
                                                });
    //显示android原生弹窗
    var msg  = "blablablabla";
    cordova.plugins.pujiapay.showAlert(msg, function success(e){
                                                    //成功回调
                                                },function error(e){
                                                    //失败回调
                                                });
	//动态从服务器获取价格，返回json
	cordova.plugins.pujiapay.requestPrice(function success(e){},function error(e){});
*/

exports.pay = function (paymentInfo, consumable, successCallback, errorCallback) {
		if(!paymentInfo){
			errorCallback && errorCallback("Please enter order information");
		}else{
			exec(successCallback, errorCallback, "PujiaPay", "pay", [paymentInfo,consumable]);
		}
};

exports.restore_items = function (paymentInfo, successCallback, errorCallback) {
		exec(successCallback, errorCallback, "PujiaPay", "restore_items", [paymentInfo]);
};

exports.showAlert = function (msg, successCallback, errorCallback) {
		if(!msg){
			errorCallback && errorCallback("Please enter message");
		}else{
			exec(successCallback, errorCallback, "PujiaPay", "alert", [msg]);
		}
};

exports.init = function (successCallback, errorCallback) {
        console.log("store is ready");
		exec(successCallback, errorCallback, "PujiaPay", "init", null);
};

exports.requestPrice = function (successCallback, errorCallback) {
		exec(successCallback, errorCallback, "PujiaPay", "request_price", null);
};

});
